Require Import SCAP.
Require Import CAP.
Require Import Arith.
Require Import MarkSweepGC.
Require Import IMarkSweepGC.

Theorem igcInitRetImplOk :
  iseqOkS imarkSweepGCP igcInitRetPre igcInitRetGuar igcInitRetImpl.
Proof.
  unfold igcInitRetImpl.
  iseqWeakSolver PsimplimarkSweepGC.

  intros s [G [W [free [objs [ohpSt [ohpEnd [freePtr [stTop [numfree
    [Hroot [Hnumfree [Hphase [Hst [Hed [Hobjs [Hset_eq Hp]]]]]]]]]]]]]]]].
  sconjLift4 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  rewrite (swStep Hp); trivial.
  rewrite addiuStep0.
  split; trivial.
  intros.
  subst s'.
  clear Hp Hset_eq Hobjs Hed Hst Hphase numfree stTop freePtr
    Hnumfree ohpEnd ohpSt objs free W G Hroot.
  split.
  intros.
  destruct H as [Hroot [Hnumfree [Hphase [Hst [Hed [Hobjs [Hset_eq Hp]]]]]]].
  repeat (split; trivial).
  stSimpl.
  sconjLift4 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  hypReplace Hp (contUpdateSt Hp (rget s rtop)).
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR Hp)))))).
  sconjLift2 Hp.
  unfold objHdrs, fas; simpl.
  apply unitIL.
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  sconjLift2 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift2 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  apply (sconjImplR (sconjComm Hp)); clear h Hp; intros h Hp.
  apply (sconjImplR (sconjComm Hp)); clear h Hp; intros h Hp.
  apply (sconjImplR (sconjComm Hp)); clear h Hp; intros h Hp.
  apply (sconjImplR (sconjComm Hp)); clear h Hp; intros h Hp.
  apply (sconjComm Hp).
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply aconjIntro.
  apply (aconjEL Hp).
  hypReplace Hp (aconjER Hp).
  unfold objHp, fas; simpl.
  apply unitIL.
  apply Hp.
  split; stSimpl.
  intros.
  destruct r; trivial.
  elimtype False; apply H0; reflexivity.
  split; reflexivity.
Qed.

Theorem imarkSweepImplOk :
  iseqOkS imarkSweepGCP imarkSweepGCPre imarkSweepGCGuar imarkSweepGCImpl.
Proof.
  unfold imarkSweepGCImpl.
  iseqWeakSolver PsimplimarkSweepGC.

  intros s s' _ [_ [_ Hr]].
  regEqSolver.
  
  unfold imarkSweepGCPre, imarkSweepGCGuar.
  intros s [[Hphase Hpre] | Hpre].
  rewrite addiuStep0.
  rewrite addiuStepZero; stSimpl.
  doBtestSimpl.
  clear Bt; simpl.
  2 : rewrite Hphase in Bt; elimtype False; apply Bt; reflexivity.

  (* MARK_PHASE *)
  unfold imarkPre, imarkPreP.
  stSimpl.
  split.
  apply Hpre.

  intros s' [HG [Hcall [Hcst1 Hcst0]]].
  left.
  split; trivial.
  split; [intros | idtac].
  assert (Hh := HG _ _ _ _ _ _ _ _ _ _ _ _ _ H).
  destruct Hh as [sum [stTop' [B' [G' [W' Hpost]]]]].
  exists sum; exists stTop'; exists B'; exists G'; exists W'.
  split; trivial.
  clear Hpre Hpost sum stTop' B' G' W'.
  destruct H as [Hroot [Hnumfree [_ [Hst [Hed [Hobjs [Hset_eq Hp]]]]]]].
  set (GCINFO := rget s rgcInfo |->, (ohpSt :: ohpEnd :: freePtr :: stBot
    :: stBuff :: stTop :: ohpSt :: numfree :: nil)) in * .
  intros x [Hin HnotinF].
  aconjE2 Hp.
  clear Hp.
  assert (Hin' : set_In x (B |_| (G |_| W))).
  destruct (Hset_eq x) as [_ Hin'].
  hypReplace Hin' (Hin' Hin).
  hypReplace Hin' (set_InUnion_notinR_inL _ _ _ Hin' HnotinF).
  elimSetIn.
  destruct (set_union_elim Hin') as [HinB | HinGW]; clear Hin Hin'.
  sconjLift7 Hh.
  hypReplace Hh (sconjAssocL (fasElimL HinB Hh)).
  unfold okObjAt, okFieldAt in Hh.
  linLogElim Hh.
  assert (Hgetx := contGetEqL Hh).
  sconjLift2 Hh.
  assert (Hgetx' := contGetEqL Hh).
  assert (Hpre :imarkPreP (rset (rset s rcst1 (rget s ra)) rtemp 0) B G W free objs
    ohpSt ohpEnd freePtr stBot stBuff stTop numfree
    (x |-> x0 ** 4 + x |-> x1 ** objHp (B |_| G) (set_remove x B) **
      objHp ((B |_| G) |_| W) (G |_| W))).
  clear HG Hcall Hcst1 Hcst0.
  repeat (split; trivial).
  stSimpl.
  subst GCINFO.
  sconjLift4 Hh.
  apply (sconjImplR Hh); clear Hh; intros h Hp.
  repeat (sconjLift4 Hp; apply (sconjImplR Hp); clear h Hp; intros h Hp).
  apply aconjIntro.
  sconjLift2 Hp.
  apply Hp.
  apply (sconjImplL (sconjAssocR (sconjAssocR Hp))); clear h Hp; intros h Hp.
  rewrite hpredTrueEq.
  setoid_rewrite <- (addRemoveEqv HinB).
  apply objHpIntro.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2 : apply (sconjComm Hp).
  setoid_rewrite (addRemoveEqv HinB); assumption.
  setoid_rewrite (addRemoveEqv HinB); assumption.
  rewrite hpredTrueEq.
  setoid_rewrite (addRemoveEqv HinB).
  apply Hp.
  hypReplace HG (HG _ _ _ _ _ _ _ _ _ _ _ _ _ Hpre).
  destruct HG as [sum [stTop' [B' [G' [W' [Hpost _]]]]]].
  destruct Hpost as [_ [_ [_ [_ [_ [_ [_ [_ Hp]]]]]]]].
  aconjE1 Hp.
  subst GCINFO.
  clear Hp Hh Hpre.
  sconjLift7 Hh0.
  assert (Hgetxs := contGetEqL Hh0).
  unfold hget.
  rewrite Hgetxs; rewrite Hgetx.
  sconjLift7 (sconjAssocR Hh0).
  assert (Hgetx's := contGetEqL H).
  clear H Hh0 Hcst1 Hcall Hcst0.
  rewrite Hgetx'; rewrite Hgetx's.
  split; reflexivity.
  sconjLift8of8 Hh.
  hypReplace Hh (sconjAssocL (fasElimL HinGW Hh)).
  unfold okObjAt, okFieldAt in Hh.
  linLogElim Hh.
  assert (Hgetx := contGetEqL Hh).
  sconjLift2 Hh.
  assert (Hgetx' := contGetEqL Hh).
  assert (Hpre :imarkPreP (rset (rset s rcst1 (rget s ra)) rtemp 0) B G W free objs
    ohpSt ohpEnd freePtr stBot stBuff stTop numfree
    (x |-> x0 ** 4 + x |-> x1 ** objHp ((B |_| G) |_| W) (set_remove x (G |_| W)) **
      objHp (B |_| G) B)).
  subst GCINFO.
  clear HG Hcall Hcst1 Hcst0.
  repeat (split; trivial).
  stSimpl.
  sconjLift4 Hh.
  apply (sconjImplR Hh); clear Hh; intros h Hp.
  sconjLift4 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift4 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift4 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift4 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift4 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply aconjIntro.
  sconjLift2 Hp.
  apply Hp.
  apply (sconjImplR (sconjComm (sconjAssocR (sconjAssocR Hp)))); clear h Hp; intros h Hp.
  rewrite hpredTrueEq.
  setoid_rewrite <- (addRemoveEqv HinGW).
  apply objHpIntro.
  apply (sconjImplL Hp); clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2 : apply (sconjComm Hp).
  assumption.
  assumption.
  hypReplace HG (HG _ _ _ _ _ _ _ _ _ _ _ _ _ Hpre).
  destruct HG as [sum [stTop' [B' [G' [W' [Hpost _]]]]]].
  destruct Hpost as [_ [_ [_ [_ [_ [_ [_ [_ Hp]]]]]]]].
  aconjE1 Hp.
  clear Hp Hh Hpre.
  sconjLift7 Hh0.
  assert (Hgetxs := contGetEqL Hh0).
  unfold hget.
  rewrite Hgetxs; rewrite Hgetx.
  sconjLift7 (sconjAssocR Hh0).
  assert (Hgetx's := contGetEqL H).
  clear H Hh0.
  rewrite Hgetx'; rewrite Hgetx's.
  split; reflexivity.

  clear HG Hpre Hphase.
  generalize Hcst1; stSimpl;
    clear Hcst1; intro Hcst1.
  generalize Hcst0; stSimpl;
    clear Hcst0; intro Hcst0.
  split; trivial.
  intros r Hsaved.
  hypReplace Hcall (Hcall r Hsaved).
  destruct Hsaved as [H | [H | [H | [H | [H | [H | [H | [H | [H | H]]]]]]]]];
    try (subst r; rewrite <- Hcall; reflexivity).
  elim H.

  destruct Hpre as [[Hphase Hpre] | [Hphase Hpre]].
  rewrite addiuStep.
  rewrite addiuStep; stSimpl.
  doBtestSimpl.
  rewrite Hphase in Bt; inversion Bt.
  (* SWEEP_PHASE *)
  clear Bt.
  rewrite addiuStepZero; stSimpl.
  doBtestSimpl.
  clear Bt.
  split.
  unfold isweepPre, isweepPreP.
  stSimpl.
  apply Hpre.

  unfold isweepGuar.
  stSimpl.
  intros s' [HG [Hcall [Hcst1 Hcst0]]].
  right; left.
  split; trivial.
  split; [intros | idtac].
  assert (Hh := HG _ _ _ _ _ _ _ _ _ _ _ _ _ H).
  destruct Hh as [num [W' [free' [swept' [freePtr' [sweepAt' 
    [numfree' Hpost]]]]]]].
  exists num; exists W'; exists free'; exists swept'; exists freePtr';
    exists sweepAt'; exists numfree'.
  split; trivial.
  clear Hpre Hpost num sweepAt' swept' free' W' freePtr' numfree'.
  destruct H as [Hroot [_ [Hnum [Hst [Hed [Hdif [Hobjs [Hswpt
    [Hk [Hset_eq Hp]]]]]]]]]].
  set (GCINFO := rget s rgcInfo |->, (ohpSt :: ohpEnd :: freePtr :: stBot
    :: stBuff :: stBot :: sweepAt :: numfree :: nil)) in * .
  intros x HinB.
  aconjE2 Hp.
  clear Hp.
  sconjLift7of7 Hh.
  hypReplace Hh (sconjAssocL (fasElimL HinB Hh)).
  unfold okObjAt, okFieldAt in Hh.
  linLogElim Hh.
  assert (Hgetx := contGetEqL Hh).
  sconjLift2 Hh.
  assert (Hgetx' := contGetEqL Hh).
  assert (Hpre : isweepPreP (rset (rset (rset s rcst1 (0 + rget s ra)) rtemp (0 + 0)) rtemp
    (1 + 0)) B W objs free swept ohpSt ohpEnd freePtr stBot stBuff sweepAt numfree
  (x |-> x0 ** 4 + x |-> x1 ** objHp B (set_remove x B))).
  clear HG Hcall Hcst1 Hcst0.
  subst GCINFO.
  repeat (split; trivial).
  stSimpl.
  sconjLift4 Hh.
  apply (sconjImplR Hh); clear Hh; intros h Hp.
  repeat (sconjLift4 Hp; apply (sconjImplR Hp); clear h Hp; intros h Hp).
  sconjLift4of4 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply aconjIntro.
  sconjLift2 Hp.
  apply Hp.
  rewrite hpredTrueEq.
  setoid_rewrite <- (addRemoveEqv HinB).
  apply objHpIntro.
  apply (sconjImpl (sconjAssocR Hp)); clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2 : apply (sconjComm Hp).
  setoid_rewrite (addRemoveEqv HinB); assumption.
  setoid_rewrite (addRemoveEqv HinB); assumption.
  rewrite hpredTrueEq.
  setoid_rewrite (addRemoveEqv HinB).
  apply Hp.
  hypReplace HG (HG _ _ _ _ _ _ _ _ _ _ _ _ _ Hpre).
  destruct HG as [num [W' [free' [swept' [freePtr' [sweepAt'
    [numfree' [Hpost _]]]]]]]].
  destruct Hpost as [_ [_ [_ [_ [_ [_ [_ [_ [_ [_ [_ Hp]]]]]]]]]]].
  aconjE1 Hp.
  subst GCINFO.
  clear Hp Hh Hpre.
  sconjLift7 Hh0.
  assert (Hgetxs := contGetEqL Hh0).
  unfold hget.
  rewrite Hgetxs; rewrite Hgetx.
  sconjLift7 (sconjAssocR Hh0).
  assert (Hgetx's := contGetEqL H).
  clear H Hh0 Hcst1 Hcst0 Hcall.
  rewrite Hgetx'; rewrite Hgetx's.
  split; reflexivity.

  clear HG Hpre Hphase.
  split; trivial.
  simpl in Hcst1.
  intros r Hsaved.
  hypReplace Hcall (Hcall r Hsaved).
  destruct Hsaved as [H | [H | [H | [H | [H | [H | [H | [H | [H | H]]]]]]]]];
    try (subst r; rewrite <- Hcall; reflexivity).
  elim H.

  rewrite Hphase in Bt; elimtype False; apply Bt; reflexivity.

  rewrite addiuStep0.
  rewrite addiuStepZero; stSimpl.
  doBtestSimpl.
  rewrite Hphase in Bt; inversion Bt.
  clear Bt.
  rewrite addiuStepZero; stSimpl.
  doBtestSimpl.
  rewrite Hphase in Bt; inversion Bt.
  clear Bt.
  rewrite addiuStepZero; stSimpl.
  doBtestSimpl.
  rewrite Hphase in Bt; elimtype False; apply Bt; reflexivity.
  (* IDLE_PHASE *)
  clear Bt.
  destruct Hpre as [B [free [objs [ohpSt [ohpEnd [freePtr [stBot [stBuff
    [numfree [Hroot [Hnumfree [Hphase' [Hst [Hed [Hobjs
      [Hset_eq Hp]]]]]]]]]]]]]]]].
  sconjLift3 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  assert (HgetNum := contGetEqL Hp).
  rewrite (lwStep Hp); trivial.
  rewrite addiuStepZero; stSimpl.
  rewrite sltuStep; stSimpl.
  doBtestSimpl.
  (* IDLE_PHASE /\ numfree >= FREE_THRESHOLD *)
  unfold return1Guar, return1Pre.
  rewrite blt_false; trivial.
  stSimpl.
  clear Hp Hset_eq Hobjs Hed Hst Hroot stBuff stBot freePtr ohpSt
    Hphase' Hnumfree ohpEnd objs free B.
  split; trivial.
  intros s' Hs.
  subst s'.
  right; right.
  split; trivial.
  unfold imarkSweepGCInitGuar.
  split.
  intros.
  assert (Hpre := H).
  destruct H as [_ [_ [_ [_ [_ [_ [_ Hp]]]]]]].
  sconjLift3 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  assert (HgetNum' := contGetEqL Hp).
  rewrite HgetNum' in HgetNum; inversion HgetNum.
  subst numfree0; clear HgetNum HgetNum' Hp.
  split; intro Hnum.
  elimtype False; apply (lt_irrefl numfree).
  apply lt_le_trans with 10; trivial.
  unfold imarkSweepGCInitPreP, hget.
  stSimpl.
  split; [intros | apply Hpre].
  split; reflexivity.
  clear HgetNum Hphase Bt.
  split; trivial.
  intros r Hsaved.
  destruct Hsaved as [H | [H | [H | [H | [H | [H | [H | [H | [H | H]]]]]]]]];
    try (subst r; reflexivity).
  elim H.
  (* IDLE_PHASE /\ numfree < FREE_THREADHOLD *)
  rewrite blt_true; trivial.
  rewrite addiuStepZero; stSimpl.
  sconjLift5 Hp.
  rewrite (lwStep Hp); trivial.
  assert (Hgetbot := contGetEqL Hp).
  sconjLift5 Hp.
  rewrite (lwStep Hp); trivial.
  assert (Hgetbuff := contGetEqL Hp).
  sconjLift5 Hp.
  rewrite (lwStep Hp); trivial.
  rewrite addiuStep0.
  unfold markFieldPre, setHp; stSimpl.
  unfold markFieldGuar; stSimpl.
  split.
  split.
  destruct Hroot as [Hatom | HinB].
  left; assumption.
  right.
  assert (Hin : set_In (rget s rroot) objs).
  elimSetIn.
  split.
  eapply MSPtrGtFour.
  apply Hin.
  apply Hobjs.
  split.
  eapply MSPtrNotAtom.
  apply Hin.
  apply Hst.
  apply Hobjs.
  exists empty_set.
  right.
  split; auto.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR Hp)))).
  sconjLift5 Hp.
  hypReplace Hp (sconjAssocL (fasElimL (set_union_intro1 _ _ free HinB) Hp)).
  linLogIntro.
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  unfold objHdrs, fas, fas'; simpl.
  apply unitIL.
  sconjLift6 Hp.
  apply (sconjImplR Hp).
  intros; linLogIntro.
  intros s' [HGa [HGna Hr]].
  unfold igcInitRetPre, igcInitRetPreP.
  regRewrite rroot.
  regRewrite rphase; stSimpl.
  regRewrite rgcInfo; stSimpl.
  regRewrite rbot; stSimpl.
  regRewrite rbuff; stSimpl.
  unfold setHp.
  destruct Hroot as [Hatom | HinB].
  regRewrite rbot; stSimpl.
  regRewrite rbuff; stSimpl.
  clear Hr HGna.
  exists empty_set; exists B; exists free; exists objs; exists ohpSt;
    exists ohpEnd; exists freePtr; exists stBot; exists numfree.
  rewrite <- (set_unionEmptyL B).
  repeat (split; trivial).
  left; assumption.
  destruct (HGa (or_introl _ Hatom)) as [Hs Hrswp]; clear HGa.
  rewrite Hs; rewrite <- Hrswp; clear Hs Hrswp.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR Hp))))))).
  sconjLift2 Hp.
  unfold objHdrs, fas; simpl.
  apply unitIL.
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  sconjLift2 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplL Hp); clear h Hp; intros h Hp.
  smartAssocL Hp.
  sconjLift8of8 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift7of7 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift6of6 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift3 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift4of4 Hp.
  sconjLift2 Hp.
  sconjLift3 Hp.
  apply Hp.

  exists (rget s rroot :: empty_set); exists (set_remove (rget s rroot) B); 
    exists free; exists objs; exists ohpSt; exists ohpEnd; 
      exists freePtr; exists stBot; exists numfree.
  clear Hr HGa.
  assert (HnotinF : ~ set_In (rget s rroot) free).
  intro HinF.
  aconjE2 Hp.
  hypReplace Hh (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR Hh)))))).
  sconjLift5 Hh.
  assert (Hpf := inFreeListVal _ _ _ _ _ Hh HinF).
  linLogElim Hpf.
  sconjLift6of6 Hh.
  hypReplace Hh (sconjAssocL (fasElimL HinB Hh)).
  unfold okObjAt, okFieldAt in Hh.
  linLogElim Hh.
  sconjLift2 Hh.
  assert (Hgetlr := contGetEqL Hh).
  sconjLift2 Hpf.
  assert (Hgetlr' := contGetEqL Hpf).
  rewrite Hgetlr' in Hgetlr; inversion Hgetlr.
  subst x1; clear Hgetlr Hgetlr' Hp Hh Hpf.
  destruct H6 as [Ha | Hi].
  inversion_clear Ha.
  inversion_clear H.
  inversion_clear H0.
  assert (~ set_In INFREELIST objs).
  eapply inFreeListnotinMSobjs; eauto.
  apply H.
  elimSetIn.
  assert (Hin : set_In (rget s rroot) objs).
  elimSetIn.
  assert (Hna : ~ atomP (rget s rroot)).
  eapply MSPtrNotAtom.
  apply Hin.
  apply Hst.
  apply Hobjs.
  assert (Hset_eq' : set_eqv B
    ((rget s rroot :: empty_set) |_| set_remove (rget s rroot) B)).
  split; intro; elimSetIn.
  Opaque set_eqv.
  repeat (split; trivial).
  Transparent set_eqv.
  right; elimSetIn.
  setoid_rewrite <- Hset_eq'; assumption.
  apply sconjGLift3'.
  apply sconjGLift2'.
  apply HGna; trivial; clear HGna.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR Hp))))))).
  sconjLift2 Hp.
  apply sconjGLift2'.
  Opaque set_union.
  unfold objHdrs, fas; simpl.
  apply unitIL.
  apply sconjGLift3'.
  apply sconjAssocL.
  apply (sconjImpl Hp); clear Hp; intros h Hp.
  assert (Hin' : set_In (rget s rroot) (B |_| free)).
  elimSetIn.
  hypReplace Hp (objHdrsElim _ _ _ _ Hin' Hp).
  apply (sconjImplL (sconjComm Hp)); clear h Hp; intros h Hp.
  assert (h ||- objHdrs (set_remove (rget s rroot) B |_| free) 0).
  rewrite hpredTrueEq.
  rewrite <- (not_In_removeEq _ _ HnotinF).
  setoid_rewrite <- (set_removeUnionDistrib (rget s rroot) B free).
  apply Hp.
  apply H.
  sconjLift2 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  smartAssocL Hp.
  sconjLift8of8 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift7of7 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift6of6 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift3 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift4of4 Hp.
  sconjLift2 Hp.
  sconjLift3 Hp.
  apply Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply aconjIntro.
  linLogIntro.
  hypReplace Hp (aconjER Hp).
  rewrite hpredTrueEq.
  setoid_rewrite <- Hset_eq'.
  apply Hp.
 
  clear Hp Hset_eq Hobjs Hed Hst Hroot ohpSt Hnumfree Hphase'
    Hnumfree freePtr ohpEnd objs free B.

  intros s'' [s' [[HGa [HGna Hr]] HGret]].
  right; right.
  split; trivial.
  split.
  intros.
  destruct H as [Hroot [Hnumfree [Hphase' [Hst [Hed [Hobjs [Hset_eq Hp]]]]]]].
  sconjLift3 Hp.
  unfold contL in Hp.
  smartAssocL Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  assert (Hgetbot' := contGetEqL Hp).
  rewrite Hgetbot' in Hgetbot; inversion Hgetbot.
  subst stBot0; clear Hgetbot' Hgetbot.
  sconjLift2 Hp; smartAssocL Hp.
  assert (Hgetbuff' := contGetEqL Hp).
  rewrite Hgetbuff' in Hgetbuff; inversion Hgetbuff.
  subst stBuff0; clear Hgetbuff Hgetbuff'.
  sconjLift2 Hp; smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  assert (HgetNum' := contGetEqL Hp).
  rewrite HgetNum' in HgetNum; inversion HgetNum.
  rewrite H0 in Hnumfree; subst numfree0; clear HgetNum' HgetNum.

  split; intro Hnum.
  destruct Hroot as [Hatom | HinB].
  (* IDLE_PHASE /\ numfree < FREE_THREADHOLD /\ atomP (rget s rroot) *)
  split.
  intros x H.
  aconjE2 Hp.
  rename Hp into Hp0; rename Hh into Hp.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR Hp)))))).
  sconjLift6of6 Hp.
  hypReplace Hp (sconjAssocL (fasElimL H Hp)).
  unfold okObjAt, okFieldAt in Hp.
  linLogElim Hp.
  assert (Hgetl := contGetEqL Hp).
  sconjLift2 Hp.
  assert (Hgetr := contGetEqL Hp).
  destruct (HGa (or_introl _ Hatom)) as [Hs Hrswp]; clear HGa HGna Hp0.
  destruct HGret as [HGret [Hr' Hra]].
  unfold uhset in Hs.
  rewrite <- Hs in Hp.
  assert (imarkPreP s'' empty_set empty_set B free objs ohpSt ohpEnd freePtr
    (rget s' rbot) (rget s' rbuff) (rget s' rtop) numfree 
    (x |-> x0 ** 4 + x |-> x1 ** objHp B (set_remove x B))).
  apply HGret with stBot; clear HGret.
  repeat (split; trivial).
  regRewrite rroot; stSimpl.
  left; assumption.
  regRewrite rphase; stSimpl; reflexivity.
  unfold setHp.
  regRewrite rbot; stSimpl.
  regRewrite rbuff; stSimpl.
  rewrite <- Hrswp.
  regRewrite rgcInfo; stSimpl.
  clear Hr Hr'.
  unfold objHdrs, fas; simpl.
  apply unitIL.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR Hp)))))))).
  sconjLift4 Hp.
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  sconjLift4 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift4of4 Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  smartAssocL Hp.
  sconjLift4 Hp.
  sconjLift4 Hp.
  sconjLift4 Hp.
  sconjLift4 Hp.
  hypReplace Hp (sconjAssocR (sconjAssocR Hp)).
  apply (sconjImpl (sconjComm Hp)); clear h Hp; intros h Hp.
  sconjLift2 Hp.
  sconjLift3 Hp.
  sconjLift4 Hp.
  sconjLift5 Hp.
  sconjLift6 Hp.
  sconjLift7 Hp.
  sconjLift8of8 Hp.
  apply Hp.
  apply aconjIntro.
  smartAssocL Hp.
  sconjLift2 Hp.
  apply Hp.
  rewrite <- (set_unionEmptyL B).
  rewrite hpredTrueEq.
  setoid_rewrite <- (addRemoveEqv H).
  apply objHpIntro.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2: apply (sconjComm Hp).
  setoid_rewrite (addRemoveEqv H); assumption.
  setoid_rewrite (addRemoveEqv H); assumption.
  rewrite hpredTrueEq.
  setoid_rewrite (addRemoveEqv H); apply Hp.
  clear Hp Hr HGret Hr'.
  destruct H0 as [_ [_ [_ [_ [_ [_ [_ Hp]]]]]]].
  aconjE1 Hp.
  sconjLift8 Hh.
  assert (Hgetr' := contGetEqL Hh).
  unfold hget.
  rewrite Hgetr; rewrite Hgetr'.
  sconjLift8 Hh.
  assert (Hgetl' := contGetEqL Hh).
  rewrite Hgetl; rewrite Hgetl'.
  split; reflexivity.

  destruct (HGa (or_introl _ Hatom)) as [Hs Hrswp]; clear HGa HGna.
  destruct HGret as [HGret [Hr' Hra]].
  rewrite <- Hs in Hp.
  assert (imarkPreP s'' empty_set empty_set B free objs ohpSt ohpEnd freePtr
    (rget s' rbot) (rget s' rbuff) (rget s' rtop) numfree A).
  apply HGret with stBot; clear HGret.
  repeat (split; trivial).
  regRewrite rroot; stSimpl.
  left; assumption.
  regRewrite rphase; stSimpl; reflexivity.
  unfold setHp.
  regRewrite rbot; stSimpl.
  regRewrite rbuff; stSimpl.
  rewrite <- Hrswp.
  regRewrite rgcInfo; stSimpl.
  clear Hr Hr'.
  unfold objHdrs, fas; simpl.
  apply unitIL.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR Hp))))))).
  sconjLift2 Hp.
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  sconjLift2 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift2 Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  smartAssocL Hp.
  sconjLift2 Hp.
  sconjLift3 Hp.
  sconjLift4 Hp.
  sconjLift5 Hp.
  sconjLift6 Hp.
  sconjLift7 Hp.
  sconjLift8of8 Hp.
  apply Hp.
  apply aconjIntro.
  apply (aconjEL Hp).
  rewrite hpredTrueEq.
  rewrite <- (set_unionEmptyL B).
  apply (aconjER Hp).
  generalize H.
  regRewrite rbot; stSimpl.
  regRewrite rbuff; stSimpl.
  rewrite <- Hrswp.
  clear H Hp; intro Hpost.
  exists empty_set; exists B; exists stBot; apply Hpost.
  
  (* IDLE_PHASE /\ numfree < FREE_THREADHOLD /\ ~ atomP (rget s rroot) //in B *)
  assert (Hin : set_In (rget s rroot) objs).
  elimSetIn.
  assert (Hna : ~ atomP (rget s rroot)).
  eapply MSPtrNotAtom.
  apply Hin.
  apply Hst.
  apply Hobjs.
  assert (HnotinF : ~ set_In (rget s rroot) free).
  intro HinF.
  aconjE2 Hp.
  clear HGa HGna Hr HGret Hphase' Hnum Hp.
  hypReplace Hh (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR Hh)))))).
  sconjLift5 Hh.
  assert (Hpf := inFreeListVal _ _ _ _ _ Hh HinF).
  linLogElim Hpf.
  sconjLift2 Hpf.
  assert (Hgetr' := contGetEqL Hpf).
  sconjLift6of6 Hh.
  hypReplace Hh (sconjAssocL (fasElimL HinB Hh)).
  unfold okObjAt, okFieldAt in Hh.
  linLogElim Hh.
  sconjLift2 Hh.
  assert (Hgetlr := contGetEqL Hh).
  rewrite Hgetr' in Hgetlr; inversion Hgetlr.
  subst x1; clear Hgetlr Hgetr' Hh Hpf.
  destruct H6 as [Ha | Hi].
  inversion_clear Ha.
  inversion_clear H.
  inversion_clear H0.
  assert (~ set_In INFREELIST objs).
  eapply inFreeListnotinMSobjs; eauto.
  apply H.
  elimSetIn.
  split.
  intros x H.
  aconjE2 Hp.
  clear Hp; rename Hh into Hp.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR Hp)))))).
  sconjLift6of6 Hp.
  hypReplace Hp (sconjAssocL (fasElimL H Hp)).
  unfold okObjAt, okFieldAt in Hp.
  linLogElim Hp.
  assert (Hgetl := contGetEqL Hp).
  sconjLift2 Hp.
  assert (Hgetr := contGetEqL Hp).

  destruct HGret as [HGret [Hr' Hra]].
  assert (imarkPreP s'' empty_set (set_add (rget s rroot) empty_set) (set_remove (rget s rroot) B)
    free objs ohpSt ohpEnd freePtr (rget s' rbot) (rget s' rbuff) (rget s' rtop)
    numfree (x |-> x0 ** 4 + x |-> x1 ** objHp B (set_remove x B))).
  apply HGret with stBot; clear HGret.
  Opaque set_eqv.
  repeat (split; trivial).
  regRewrite rroot; stSimpl.
  right; elimSetIn.
  regRewrite rphase; stSimpl; reflexivity.
  setoid_replace (set_add (rget s rroot) empty_set |_| set_remove (rget s rroot) B) with B.
  Transparent set_eqv.
  split; intro; elimSetIn.
  assumption.
  apply sconjGLift3'.
  apply sconjGLift2'.
  unfold setHp.
  apply HGna; trivial; clear HGa HGna.
  regRewrite rgcInfo; stSimpl.
  regRewrite rbot; stSimpl.
  regRewrite rbuff; stSimpl.
  clear Hr Hr' Hphase' Hra.
  apply sconjGLift2'.
  unfold objHdrs, fas; simpl.
  apply unitIL.
  apply sconjGLift3'.
  apply sconjAssocL.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR Hp))))))).
  sconjLift5 Hp.
  apply (sconjImpl Hp); clear Hp; intros h Hp.
  assert (Hin' : set_In (rget s rroot) (B |_| free)).
  elimSetIn.
  hypReplace Hp (objHdrsElim _ _ _ _ Hin' Hp).
  apply (sconjImplL (sconjComm Hp)); clear h Hp; intros h Hp.
  assert (h ||- objHdrs (set_remove (rget s rroot) B |_| free) 0).
  rewrite hpredTrueEq.
  rewrite <- (not_In_removeEq _ _ HnotinF).
  setoid_rewrite <- (set_removeUnionDistrib (rget s rroot) B free).
  apply Hp.
  apply H0.

  sconjLift5 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  smartAssocL Hp.
  apply sconjAssocL.
  apply (sconjImpl (sconjComm (sconjAssocR (sconjAssocR Hp)))); clear h Hp; intros h Hp.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR Hp))))))).
  apply (sconjImplL Hp); clear h Hp; intros h Hp.
  smartAssocL Hp.
  sconjLift2 Hp.
  sconjLift3 Hp.
  sconjLift4 Hp.
  sconjLift5 Hp.
  sconjLift6 Hp.
  sconjLift7 Hp.
  sconjLift8of8 Hp.
  apply Hp.
  apply aconjIntro.
  smartAssocL Hp.
  sconjLift2 Hp.
  apply Hp.
  assert (h ||- objHp B B).
  rewrite hpredTrueEq.
  setoid_rewrite <- (addRemoveEqv H).
  apply objHpIntro.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2 : apply (sconjComm Hp).
  setoid_rewrite (addRemoveEqv H); assumption.
  setoid_rewrite (addRemoveEqv H); assumption.
  rewrite hpredTrueEq.
  setoid_rewrite (addRemoveEqv H); assumption.
  rewrite hpredTrueEq.
  setoid_replace (set_add (rget s rroot) empty_set |_| set_remove (rget s rroot) B) with B.
  split; intro; elimSetIn.
  split; intro; elimSetIn.
  apply H0.
  clear Hp Hr HGret Hr' HGa HGna.
  destruct H0 as [_ [_ [_ [_ [_ [_ [_ Hp]]]]]]].
  aconjE1 Hp.
  sconjLift8 Hh.
  assert (Hgetr' := contGetEqL Hh).
  sconjLift8 Hh.
  assert (Hgetl' := contGetEqL Hh).
  clear Hh Hp.
  unfold hget.
  rewrite Hgetl; rewrite Hgetl'; rewrite Hgetr; rewrite Hgetr'.
  split; reflexivity.
  
  destruct HGret as [HGret [Hr' Hra]].
  assert (imarkPreP s'' empty_set (set_add (rget s rroot) empty_set) (set_remove (rget s rroot) B)
    free objs ohpSt ohpEnd freePtr (rget s' rbot) (rget s' rbuff) (rget s' rtop)
    numfree A).
  apply HGret with stBot; clear HGret.
  Opaque set_eqv.
  repeat (split; trivial).
  regRewrite rroot; stSimpl.
  right; elimSetIn.
  regRewrite rphase; stSimpl; reflexivity.
  setoid_replace (set_add (rget s rroot) empty_set |_| set_remove (rget s rroot) B) with B.
  Transparent set_eqv.
  split; intro; elimSetIn.
  assumption.
  apply sconjGLift3'.
  apply sconjGLift2'.
  unfold setHp.
  apply HGna; trivial; clear HGa HGna.
  regRewrite rgcInfo; stSimpl.
  regRewrite rbot; stSimpl.
  regRewrite rbuff; stSimpl.
  clear Hr Hr' Hphase' Hra.
  apply sconjGLift2'.
  unfold objHdrs, fas; simpl.
  apply unitIL.
  apply sconjGLift3'.
  apply sconjAssocL.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR Hp))))))).
  sconjLift2 Hp.
  apply (sconjImpl Hp); clear Hp; intros h Hp.
  assert (Hin' : set_In (rget s rroot) (B |_| free)).
  elimSetIn.
  hypReplace Hp (objHdrsElim _ _ _ _ Hin' Hp).
  apply (sconjImplL (sconjComm Hp)); clear h Hp; intros h Hp.
  assert (h ||- objHdrs (set_remove (rget s rroot) B |_| free) 0).
  rewrite hpredTrueEq.
  rewrite <- (not_In_removeEq _ _ HnotinF).
  setoid_rewrite <- (set_removeUnionDistrib (rget s rroot) B free).
  apply Hp.
  apply H.

  sconjLift2 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift2 Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  smartAssocL Hp.
  sconjLift2 Hp.
  sconjLift3 Hp.
  sconjLift4 Hp.
  sconjLift5 Hp.
  sconjLift6 Hp.
  sconjLift7 Hp.
  sconjLift8of8 Hp.
  apply Hp.
  apply aconjIntro.
  apply (aconjEL Hp).
  hypReplace Hp (aconjER Hp).
  rewrite hpredTrueEq.
  setoid_replace (set_add (rget s rroot) empty_set |_| set_remove (rget s rroot) B) with B.
  split; intro; elimSetIn.
  split; intro; elimSetIn.
  apply Hp.
  generalize H.
  regRewrite rbot; stSimpl.
  regRewrite rbuff; stSimpl.
  clear H Hp Hr Hr' Hphase HGret HGa HGna Hphase'.
  intro Hpost.
  exists (set_add (rget s rroot) empty_set); exists (set_remove (rget s rroot) B);
    exists (rget s' rtop); apply Hpost.

  elimtype False; apply (lt_irrefl numfree).
  apply lt_le_trans with 10; trivial.

  clear HGa HGna HgetNum Hgetbot Hgetbuff Hphase Bt.
  destruct HGret as [_ [Hr' [Hra Hcst0]]].
  split.
  apply raAndOthers.
  intros r Hsaved.
  destruct Hsaved as [H | [H | [H | [H | [H | [H | [H | [H | H]]]]]]]];
    try (subst r; regEqSolver; regEqSolver).
  elim H.
  rewrite Hra.
  regRewrite rcst1.
  stSimpl; reflexivity.
  rewrite <- Hcst0; regEqSolver.
Qed.

Theorem imarkSweepGCNewImplOk :
  iseqOkS imarkSweepNewObjP newObjNewPre newObjNewGuar newObjNewImpl.
Proof.
  unfold newObjNewImpl.
  iseqWeakSolver  PsimplimarkSweepNewObj.

  unfold newObjNewPre, imarkSweepGCPre.
  intros s Hpre.
  destruct Hpre as [[Hphase Hpre] | [[Hphase Hpre] | [Hphase Hpre]]].

  (* MARK_PHASE *)
  destruct Hpre as [B [G [W [free [objs [ohpSt [ohpEnd [freePtr [stBot
    [stBuff [stTop [numfree [Hroot [Hnumfree [_ [Hst [Hed [Hobjs
      [Hset_eq Hp]]]]]]]]]]]]]]]]]]].

  sconjLift5 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  rewrite (lwStep Hp); trivial.
  assert (Hgetfp := contGetEqL Hp).
  rewrite addiuStepZero; stSimpl.
  doBtestSimpl.

  (* MARK_PHASE /\ freePtr = NULL / free = empty_set *)
  unfold return0Guar, return0Pre.
  split; trivial.
  assert (Hfpr := contGetEqL Hp).
  clear B G W free objs ohpSt ohpEnd stBot stBuff stTop numfree 
    Hst Hed Hobjs Hset_eq Hp Hroot Hnumfree.

  intros.
  left.
  split; trivial.
  subst s'.
  split.
  intros.
  destruct H as [Hroot [Hnumfree [_ [Hst [Hed [Hobjs
    [Hset_eq Hp]]]]]]].
  assert (Hpt := Hp).
  sconjLift5 Hpt.
  linLogElim Hpt.
  sconjLift3 Hpt.
  assert (Hfpr' := contGetEqL Hpt).
  rewrite Hfpr' in Hfpr; inversion Hfpr.
  subst freePtr0; clear Hpt Hfpr' Hfpr.
  unfold newMarkPost, HpUnchangeNotInF, hget; stSimpl.
  exists empty_set; exists NULL.
  split.
  intros; split; trivial.
  split; intro He.
  subst freePtr.
  sconjLift6 Hp.
  assert (Bt := ifreeList_NULL_empty _ _ _ Hp).
  rewrite <- Bt in He; elim He; reflexivity.
  repeat (split; auto).
  split; stSimpl; trivial.
  intros.
  induction r; trivial.
  elim H1; reflexivity.
  elim H; reflexivity.
  elim H0; reflexivity.
  
  (* MARK_PHASE /\ freePtr <> NULL / free <> empty_set *)
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR Hp))).
  sconjLift6 Hp.
  assert (HF : free <> empty_set).
  intro He; subst free.
  assert (Bt' := ifreeList_empty_NULL _ freePtr _ Hp).
  apply Bt; auto.
  destruct (notEmptyIsCons HF) as [x [objs' Hobjs']].
  subst free.
  assert (Hfpin : set_In freePtr (W |_| freePtr :: objs')).
  elimSetIn.
  unfold ifreeList in Hp.
  fold ifreeList in Hp.
  linLogElim Hp.
  subst x.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (HgetNfp := contGetEqL Hp).
  sconjLift4 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp x0).
  rewrite addiuStepZero.
  sconjLift2 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift3 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift9 Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (Hgetnf := contGetEqL Hp).
  rewrite addiuStepZero; stSimpl.
  rewrite subuStep; stSimpl.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp (numfree - 1)).
  rewrite addiuStepZero; stSimpl.
  rewrite Hphase.
  unfold doBtest, negb.
  rewrite beq_false; auto.
  sconjLift9 Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (Hgetsa := contGetEqL Hp).
  rewrite addiuStep; stSimpl; trivial.
  rewrite sltuStep; stSimpl; trivial.
  rewrite blt_false.
  unfold doBtest, negb, Bool.negb.
  rewrite beq_true; trivial.
  rewrite addiuStepZero; stSimpl.
  rewrite subuStep; stSimpl.
  rewrite addiuStepZero; stSimpl.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR (sconjAssocR Hp))))))).
  sconjLift7 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  rewrite (swStep Hp); stSimpl; trivial.
  rewrite addiuStep0; stSimpl.
  split; trivial.
  
  clear Hp Hfpin HF Hset_eq Hnumfree objs' Bt Hobjs Hed Hst Hroot
    stTop stBuff stBot ohpEnd objs W G B.
  
  intros s' H.
  subst s'.
  left.
  split; trivial.
  split.
  intros.
  destruct H as [Hroot [Hnumfree [_ [Hst [Hed [Hobjs
    [Hset_eq Hp]]]]]]].
  aconjE2 Hp.
  clear Hp; rename Hh into Hp.
  sconjLift5 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  assert (Hgetfp' := contGetEqL Hp).
  rewrite Hgetfp' in Hgetfp; inversion Hgetfp.
  subst freePtr0; clear Hgetfp Hgetfp'.
  sconjLift9 Hp.
  assert (HF : free <> empty_set).
  intro He; subst free.
  assert (Bt := ifreeList_empty_NULL _ freePtr _ Hp).
  apply H6; auto.
  destruct (notEmptyIsCons HF) as [x [objs' Hobjs']].
  subst free.
  assert (Hfpin : set_In freePtr (W |_| freePtr :: objs')).
  elimSetIn.
  unfold ifreeList in Hp.
  fold ifreeList in Hp.
  linLogElim Hp.
  subst x.
  assert (HgetNfp' := contGetEqL Hp).
  rewrite HgetNfp' in HgetNfp; inversion HgetNfp.
  subst x1; clear HgetNfp HgetNfp'.
  sconjLift4 Hp.
  hypReplace Hp (contUpdateSt Hp x0).
  sconjLift2 Hp.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift3 Hp.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift9 Hp.
  assert (Hgetnf' := contGetEqL Hp).
  rewrite Hgetnf' in Hgetnf; inversion Hgetnf.
  subst numfree0; clear Hgetnf' Hgetnf.
  hypReplace Hp (contUpdateSt Hp (numfree - 1)).
  sconjLift9 Hp.
  assert (Hgetsa' := contGetEqL Hp).
  rewrite Hgetsa' in Hgetsa; inversion Hgetsa.
  subst ohpSt0; clear Hgetsa Hgetsa'.
  exists objs'; exists x0.
  split.
  unfold HpUnchangeNotInF, hget, uhset; stSimpl.
  intros x [Hxin Hxnotin].
  subst objs.
  assert (Hptrx := in_rangeMsobj_ptrP _ _ x Hst Hed Hxin).
  assert (Hptrx' := succPtr Hptrx).
  destruct (Hset_eq x) as [_ HxinBGW].
  hypReplace HxinBGW (HxinBGW Hxin).
  hypReplace HxinBGW (set_InUnion_notinR_inL _ _ _ HxinBGW Hxnotin).
  assert (HxinBGW' : set_In x (B |_| (G |_| W))).
  elimSetIn.
  clear HxinBGW H6 H7 HF H0 Hset_eq Hxin Hroot Hphase Hxnotin.
  sconjLift2 Hp.
  assert (HptrNumfree := contElim1L Hp).
  sconjLift5 Hp.
  assert (HptrNewFreePtr := contElim1L Hp).
  sconjLift4 Hp.
  assert (HptrFreePtr2 := contElim1L Hp).
  sconjLift5 Hp.
  assert (HptrFreePtr := contElim1L Hp).
  assert (HptrFreePtrHd : ptrP (freePtr - 4)).
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR (sconjAssocR Hp))))))))))).
  sconjLift3 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  apply (contElim1L Hp).
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR (sconjAssocR Hp))))))))))).
  sconjLift5 Hp.
  sconjLift6of6 Hp.
  assert (Hexfh : x <> freePtr - 4 /\ 4 + x <> freePtr - 4).
  sconjLift5 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  destruct (set_union_elim HxinBGW') as [HxinB | HxinGW]; clear HxinBGW'.
  sconjLift4 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  sconjLift3 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinGW Hp).
  destruct Hexfh as [Hexfhd Hexfhd'].
  sconjLift3 Hp.
  hypReplace Hp (sconjAssocL (sconjAssocL (sconjAssocL (sconjAssocL 
    (sconjAssocL Hp))))).
  sconjLift8 Hp.
  sconjLift8 Hp.
  sconjLift3 Hp.
  smartAssocL Hp.
  assert (Hexf : x <> freePtr /\ 4 + x <> freePtr).
  destruct (set_union_elim HxinBGW') as [HxinB | HxinGW]; clear HxinBGW'.
  sconjLift9 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  sconjLift8 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinGW Hp).
  destruct Hexf as [Hexfptr Hexfptr'].
  sconjLift9 Hp.
  sconjLift9 Hp.
  sconjLift4 Hp.
  assert (Hexf2 : x <> 4 + freePtr /\ 4 + x <> 4 + freePtr).
  destruct (set_union_elim HxinBGW') as [HxinB | HxinGW]; clear HxinBGW'.
  sconjLift3 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  sconjLift2 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinGW Hp).
  destruct Hexf2 as [Hexfptr2 Hexfptr2'].
  assert (Hexfp : x <> 8 + rget s rgcInfo /\ 4 + x <> 8 + rget s rgcInfo).
  sconjLift5 Hp.
  destruct (set_union_elim HxinBGW') as [HxinB | HxinGW]; clear HxinBGW'.
  sconjLift4 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  sconjLift3 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinGW Hp).
  destruct Hexfp as [Hexnfp Hexnfp'].
  assert (Hexn : x <> 28 + rget s rgcInfo /\ 4 + x <> 28 + rget s rgcInfo).
  sconjLift6 Hp.
  destruct (set_union_elim HxinBGW') as [HxinB | HxinGW]; clear HxinBGW'.
  sconjLift4 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  sconjLift3 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinGW Hp).
  destruct Hexn as [Hexnf Hexnf'].
  clear Hp.
  destruct s; stSimpl.
  rewrite <- (HeapgetNeq _ _ h x0 Hptrx HptrNewFreePtr Hexnfp).
  rewrite <- (HeapgetNeq _ _ (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    NULL Hptrx HptrFreePtr Hexfptr).
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    freePtr NULL) NULL Hptrx HptrFreePtr2 Hexfptr2).
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset (Heap.uset h (4 + (4 + rget (h, r)
    rgcInfo)) x0) freePtr NULL) (4 + freePtr) NULL) (numfree - 1) Hptrx HptrNumfree Hexnf).
  rewrite <- (HeapgetNeq _ _ h x0 Hptrx' HptrNewFreePtr Hexnfp').
  rewrite <- (HeapgetNeq _ _ (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    NULL Hptrx' HptrFreePtr Hexfptr').
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    freePtr NULL) NULL Hptrx' HptrFreePtr2 Hexfptr2').
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset (Heap.uset h (4 + (4 + rget (h, r)
    rgcInfo)) x0) freePtr NULL) (4 + freePtr) NULL) (numfree - 1) Hptrx' HptrNumfree Hexnf').
  split; apply HeapgetNeq; trivial.

  unfold newMarkPost, imarkPre, imarkPreP; stSimpl.
  split; intro He.
  2: rewrite He in HF; elim HF; reflexivity.
  sconjLift4 Hp.
  sconjLift6 Hp.
  assert (Hfpnotinobjs' := ifreeList_cont_notIn _ _ _ _ _ _ Hp).
  assert (HfpnotinW : ~set_In freePtr W).
  intro HfpinW.
  sconjLiftH 16 Hp.
  hypReplace Hp (sconjAssocL (fasElimL (set_union_intro2 _ G _ HfpinW) Hp)).
  unfold okObjAt, okFieldAt in Hp.
  linLogElim Hp.
  sconjLift5 Hp.
  apply (contContFalse Hp).
  repeat (split; trivial).
  intro HfpInB.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR (sconjAssocR Hp)))))))))).
  sconjLift2 Hp.
  hypReplace Hp (sconjAssocL (fasElimL HfpInB Hp)).
  sconjLift5 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  sconjLift3 Hp.
  apply (sconjDisjL Hp).
  destruct Hroot; [left; trivial | right; elimSetIn].
  subst numfree.
  rewrite <- (notInPlus' objs' freePtr Hfpnotinobjs').
  auto with arith.
  intro; elimSetIn.
  intro.
  destruct (Hset_eq a) as [_ HI].
  hypReplace HI (HI H).
  elimSetIn.
  unfold uhset; stSimpl.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR  Hp)))))))).
  sconjLift6 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  hypReplace Hp (contUpdateSt Hp MARKED).
  sconjLift3 Hp.
  smartAssocL Hp.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR Hp)))))))).
  sconjLift7 Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear Hp Hset_eq HF Hroot Hphase Hfpin H7 Hobjs H0 H6 He Hst Hed; intros h Hp.
  sconjLift6 Hp.
  sconjLift3 Hp.
  apply (sconjImpl (sconjAssocR Hp)); clear h Hp; intros h Hp.
  apply objHdrsIntro; assumption.
  sconjLift5 Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  smartAssocL Hp.
  apply sconjGLift3'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift9 Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  rewrite hpredTrueEq.
  setoid_replace (W |_| objs') with
    (set_remove freePtr (W |_| freePtr :: objs')).
  split; intro; elimSetIn.
  elim H0; reflexivity.
  assumption.
  sconjLift4 Hp.
  hypReplace Hp (sconjAssocR Hp).
  sconjLift3 Hp.
  sconjLift3 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift8 Hp.
  sconjLift9 Hp.
  linLogIntro.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  apply aconjIntro1.
  apply (sconjImpl (sconjAssocR Hp)).
  clear h Hp; intros h Hp.
  apply objHpIntro.
  apply (sconjImpl Hp).
  clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2: apply (sconjComm Hp).
  left; unfold atomP; auto with arith.
  left; unfold atomP; auto with arith.
  clear h Hp; unfold objHp.
  intros h Hp.
  apply (fasImpl Hp).
  unfold okObjAt, okFieldAt.
  clear h Hp; intros.
  linLogElim H.
  linLogIntro.
  2: apply H.
  destruct H4; [left; trivial | right; elimSetIn].
  destruct H5; [left; trivial | right; elimSetIn].
  clear h Hp; unfold objHp; intros h Hp.
  apply (fasImpl Hp).
  unfold okObjAt, okFieldAt.
  clear h Hp; intros.
  linLogElim H.
  linLogIntro.
  2: apply H.
  destruct H4; [left; trivial | right; elimSetIn].
  destruct H5; [left; trivial | right; elimSetIn].
  
  clear Hgetfp Hgetnf HgetNfp Hgetsa Hphase H6.
  split; trivial.
  intros.
  stSimpl.
  trivial.
  clear Hp Hgetfp Hgetnf HgetNfp Hgetsa Hphase H6.
  assert (set_In freePtr objs).
  elimSetIn.
  subst objs.
  destruct (rangeMSObjsElim freePtr ohpSt ohpEnd H) as [_ [k He]].
  omega.

  (* SWEEP_PHASE *)
  unfold isweepPre, isweepPreP in Hpre.
  destruct Hpre as [B [W [objs [free [swept [ohpSt [ohpEnd [freePtr [stBot
    [stBuff [sweepAt [numfree [Hroot [_ [Hnumfree [Hst [Hed [Hdiff [Hobjs
      [Hswpt [Hk [Hset_eq Hp]]]]]]]]]]]]]]]]]]]]]]. 
  sconjLift4 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  rewrite (lwStep Hp); trivial.
  assert (Hgetfp := contGetEqL Hp).
  rewrite addiuStepZero; stSimpl.
  doBtestSimpl.

  (* SWEEP_PHASE /\ freePtr = NULL / free = empty_set *)
  unfold return0Guar, return0Pre.
  split; trivial.
  assert (Hfpr := contGetEqL Hp).
  clear B W free objs swept ohpSt ohpEnd stBot stBuff numfree 
    sweepAt Hst Hed Hobjs Hdiff Hswpt Hk Hset_eq Hp Hroot Hnumfree.

  intros.
  right; left.
  split; trivial.
  subst s'.
  split.
  intros.
  destruct H as [Hroot [_ [Hnumfree [Hst [Hed [Hdiff [Hobjs
    [Hswpt [Hk [Hset_eq Hp]]]]]]]]]].
  assert (Hpt := Hp).
  sconjLift4 Hpt.
  unfold contL in Hpt.
  smartAssocL Hpt; sconjLift2 Hpt.
  smartAssocL Hpt; sconjLift2 Hpt.
  smartAssocL Hpt.
  assert (Hfpr' := contGetEqL Hpt).
  rewrite Hfpr' in Hfpr; inversion Hfpr.
  subst freePtr0; clear Hpt Hfpr' Hfpr.
  unfold newSweepPost, HpUnchangeInB, hget; stSimpl.
  exists empty_set; exists NULL.
  split.
  intros; split; trivial.
  split; intro He.
  subst freePtr.
  sconjLift6 Hp.
  assert (Bt := ifreeList_NULL_empty _ _ _ Hp).
  rewrite <- Bt in He; elim He; reflexivity.
  repeat (split; auto).
  split; stSimpl; trivial.
  intros.
  induction r; trivial.
  elim H1; reflexivity.
  elim H; reflexivity.
  elim H0; reflexivity.

  (* SWEEP_PHASE /\ freePtr <> NULL / free <> empty_set *)
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR Hp))).
  sconjLift6 Hp.
  assert (HF : free <> empty_set).
  intro He; subst free.
  assert (Bt' := ifreeList_empty_NULL _ freePtr _ Hp).
  apply Bt; auto.
  destruct (notEmptyIsCons HF) as [x [objs' Hobjs']].
  subst free.
  assert (Hfpin : set_In freePtr (W |_| freePtr :: objs')).
  elimSetIn.
  unfold ifreeList in Hp.
  fold ifreeList in Hp.
  linLogElim Hp.
  subst x.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (HgetNfp := contGetEqL Hp).
  sconjLift4 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp x0).
  rewrite addiuStepZero.
  sconjLift2 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift3 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift9 Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (Hgetnf := contGetEqL Hp).
  rewrite addiuStepZero; stSimpl.
  rewrite subuStep; stSimpl.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp (numfree - 1)).
  rewrite addiuStepZero; stSimpl.
  rewrite Hphase.
  unfold doBtest, negb.
  rewrite beq_false; auto.
  sconjLift9 Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (Hgetsa := contGetEqL Hp).
  rewrite addiuStep; stSimpl.
  rewrite sltuStep; stSimpl; trivial.
  assert (freePtr < 4 + sweepAt \/ freePtr >= 4 + sweepAt).
  omega.
  destruct H as [Hlt | Hge].
  
  (* SWEEP_PHASE /\ freePtr <> NULL /\ freePtr <  4 + sweepAt *)
  rewrite blt_true; trivial.
  unfold doBtest, negb, Bool.negb.
  rewrite beq_false; auto.
  unfold return0Pre, return0Guar.
  split; trivial.
  clear Hp Hfpin HF Hset_eq Hnumfree objs' Bt Hobjs Hed Hst Hroot
    Hswpt Hk Hdiff ohpSt swept stBuff stBot ohpEnd objs W B.

  intros s' H.
  subst s'.
  right; left.
  split; trivial.
  split.
  intros.
  destruct H as [Hroot [_ [Hnumfree [Hst [Hed [Hdiff [Hobjs
    [Hswpt [Hk [Hset_eq Hp]]]]]]]]]].
  aconjE2 Hp.
  clear Hp; rename Hh into Hp.
  sconjLift4 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  assert (Hgetfp' := contGetEqL Hp).
  rewrite Hgetfp' in Hgetfp; inversion Hgetfp.
  subst freePtr0; clear Hgetfp Hgetfp'.
  sconjLift9 Hp.
  assert (HF : free <> empty_set).
  intro He; subst free.
  assert (Bt := ifreeList_empty_NULL _ freePtr _ Hp).
  apply H6; auto.
  destruct (notEmptyIsCons HF) as [x [objs' Hobjs']].
  subst free.
  assert (Hfpin : set_In freePtr (W |_| freePtr :: objs')).
  elimSetIn.
  unfold ifreeList in Hp.
  fold ifreeList in Hp.
  linLogElim Hp.
  subst x.
  assert (HgetNfp' := contGetEqL Hp).
  rewrite HgetNfp' in HgetNfp; inversion HgetNfp.
  subst x1; clear HgetNfp HgetNfp'.
  sconjLift4 Hp.
  hypReplace Hp (contUpdateSt Hp x0).
  sconjLift2 Hp.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift3 Hp.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift9 Hp.
  assert (Hgetnf' := contGetEqL Hp).
  rewrite Hgetnf' in Hgetnf; inversion Hgetnf.
  subst numfree0; clear Hgetnf' Hgetnf.
  hypReplace Hp (contUpdateSt Hp (numfree - 1)).
  sconjLift9 Hp.
  assert (Hgetsa' := contGetEqL Hp).
  rewrite Hgetsa' in Hgetsa; inversion Hgetsa.
  subst sweepAt0; clear Hgetsa Hgetsa'.
  exists objs'; exists x0.
  split.
  unfold HpUnchangeInB, hget, uhset; stSimpl.
  intros x HxinB.
  assert (Hxin : set_In x objs).
  elimSetIn.
  subst objs.
  assert (Hptrx := in_rangeMsobj_ptrP _ _ x Hst Hed Hxin).
  assert (Hptrx' := succPtr Hptrx).
  clear H6 H7 HF H0 Hset_eq Hxin Hroot Hdiff Hphase Hswpt Hk.
  sconjLift2 Hp.
  assert (HptrNumfree := contElim1L Hp).
  sconjLift5 Hp.
  assert (HptrNewFreePtr := contElim1L Hp).
  sconjLift4 Hp.
  assert (HptrFreePtr2 := contElim1L Hp).
  sconjLift5 Hp.
  assert (HptrFreePtr := contElim1L Hp).
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR (sconjAssocR Hp))))))))))).
  sconjLift5of5 Hp.
  linLogElim Hp.
  assert (Hexf : x <> freePtr /\ 4 + x <> freePtr).
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexf as [Hexfptr Hexfptr'].
  sconjLift3 Hp.
  sconjLift2 Hp.
  assert (Hexf2 : x <> 4 + freePtr /\ 4 + x <> 4 + freePtr).
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexf2 as [Hexfptr2 Hexfptr2'].
  assert (Hexfp : x <> 8 + rget s rgcInfo /\ 4 + x <> 8 + rget s rgcInfo).
  sconjLift4 Hp.
  sconjLift2 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexfp as [Hexnfp Hexnfp'].
  assert (Hexn : x <> 28 + rget s rgcInfo /\ 4 + x <> 28 + rget s rgcInfo).
  sconjLift5 Hp.
  sconjLift2 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexn as [Hexnf Hexnf'].
  clear Hp.
  destruct s; stSimpl.
  rewrite <- (HeapgetNeq _ _ h x0 Hptrx HptrNewFreePtr Hexnfp).
  rewrite <- (HeapgetNeq _ _ (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    NULL Hptrx HptrFreePtr Hexfptr).
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    freePtr NULL) NULL Hptrx HptrFreePtr2 Hexfptr2).
  rewrite <- (HeapgetNeq _ _ h x0 Hptrx' HptrNewFreePtr Hexnfp').
  rewrite <- (HeapgetNeq _ _ (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    NULL Hptrx' HptrFreePtr Hexfptr').
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    freePtr NULL) NULL Hptrx' HptrFreePtr2 Hexfptr2').
  split; apply HeapgetNeq; trivial.

  unfold newSweepPost, isweepPre, isweepPreP; stSimpl.
  split; intro He.
  2: rewrite He in HF; elim HF; reflexivity.

  sconjLift4 Hp.
  sconjLift6 Hp.
  assert (Hfpnotinobjs' := ifreeList_cont_notIn _ _ _ _ _ _ Hp).
  assert (HfpnotinW : ~set_In freePtr W).
  intro HfpinW.
  sconjLiftH 14 Hp.
  hypReplace Hp (sconjAssocL (fasElimL HfpinW Hp)).
  unfold okObjAt, okFieldAt in Hp.
  linLogElim Hp.
  sconjLift6 Hp.
  apply (contContFalse Hp).
  repeat (split; trivial).
  intro HfpInB.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR (sconjAssocR Hp)))))))))).
  sconjLift6of6 Hp.
  linLogElim Hp.
  sconjLift3 Hp.
  sconjLift2 Hp.
  destruct (objHp_cont_neq _ _ _ _ _ _ _ HfpInB Hp) as [Hn _].
  apply Hn; trivial.
  destruct Hroot; [left; trivial | right; elimSetIn].
  subst numfree.
  rewrite <- (notInPlus' objs' freePtr Hfpnotinobjs').
  auto with arith.
  intro; elimSetIn.
  intro.
  destruct (Hset_eq a) as [_ HI].
  hypReplace HI (HI H).
  elimSetIn.
  unfold uhset; stSimpl.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR  Hp)))))))).
  sconjLift5 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  sconjLift2 Hp.
  apply sconjGLift2'.
  apply (sconjImpl Hp); clear Hp; intros h Hp.
  rewrite hpredTrueEq.
  setoid_replace (W |_| objs') with
    (set_remove freePtr (W |_| freePtr :: objs')).
  split; intro; elimSetIn.
  elim H1; reflexivity.
  assumption.
  sconjLift6 Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift6 Hp.
  apply sconjGLift3'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift5 Hp.
  apply (sconjImpl (sconjAssocR Hp)); clear h Hp; intros h Hp.
  apply (bobjHdrsIntro2 _ _ _ _ _ _ Hlt (sconjComm Hp)).
  smartAssocL Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  linLogIntro.
  sconjLift4 Hp.
  hypReplace Hp (sconjAssocR Hp).
  sconjLift3 Hp.
  sconjLift3 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift8 Hp.
  sconjLift9 Hp.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  apply aconjIntro1.
  apply objHpIntro.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2 : apply (sconjComm Hp).
  left; unfold atomP; auto with arith.
  left; unfold atomP; auto with arith.
  unfold objHp.
  apply (fasImpl Hp).
  unfold okObjAt, okFieldAt.
  clear h Hp; intros.
  linLogElim H.
  linLogIntro.
  2: apply H.
  destruct H5; [left; trivial | right; elimSetIn].
  destruct H8; [left; trivial | right; elimSetIn].
  
  clear Hgetfp Hgetnf HgetNfp Hgetsa Hphase H6.
  split; trivial.
  intros.
  stSimpl.
  trivial.

  (* SWEEP_PHASE /\ freePtr <> NULL /\ freePtr >= 4 + sweepAt *)
  rewrite blt_false; trivial.
  unfold doBtest, negb, Bool.negb.
  rewrite beq_true; trivial.
  rewrite addiuStep; stSimpl.
  rewrite subuStep; stSimpl.
  rewrite addiuStepZero; stSimpl.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR (sconjAssocR Hp))))))).
  sconjLift6 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp MARKED).
  rewrite addiuStep0; stSimpl.
  split; trivial.
  
  clear Hp Hfpin HF Hset_eq Hnumfree objs' Bt Hobjs Hed Hst Hroot
    Hswpt Hk Hdiff ohpSt swept stBuff stBot ohpEnd objs W B.

  intros s' H.
  subst s'.
  right; left.
  split; trivial.
  split.
  intros.
  destruct H as [Hroot [_ [Hnumfree [Hst [Hed [Hdiff [Hobjs
    [Hswpt [Hk [Hset_eq Hp]]]]]]]]]].
  aconjE2 Hp.
  clear Hp; rename Hh into Hp.
  sconjLift4 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  assert (Hgetfp' := contGetEqL Hp).
  rewrite Hgetfp' in Hgetfp; inversion Hgetfp.
  subst freePtr0; clear Hgetfp Hgetfp'.
  sconjLift9 Hp.
  assert (HF : free <> empty_set).
  intro He; subst free.
  assert (Bt := ifreeList_empty_NULL _ freePtr _ Hp).
  apply H6; auto.
  destruct (notEmptyIsCons HF) as [x [objs' Hobjs']].
  subst free.
  assert (Hfpin : set_In freePtr (W |_| freePtr :: objs')).
  elimSetIn.
  unfold ifreeList in Hp.
  fold ifreeList in Hp.
  linLogElim Hp.
  subst x.
  assert (HgetNfp' := contGetEqL Hp).
  rewrite HgetNfp' in HgetNfp; inversion HgetNfp.
  subst x1; clear HgetNfp HgetNfp'.
  sconjLift4 Hp.
  hypReplace Hp (contUpdateSt Hp x0).
  sconjLift2 Hp.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift3 Hp.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift9 Hp.
  assert (Hgetnf' := contGetEqL Hp).
  rewrite Hgetnf' in Hgetnf; inversion Hgetnf.
  subst numfree0; clear Hgetnf' Hgetnf.
  hypReplace Hp (contUpdateSt Hp (numfree - 1)).
  sconjLift9 Hp.
  assert (Hgetsa' := contGetEqL Hp).
  rewrite Hgetsa' in Hgetsa; inversion Hgetsa.
  subst sweepAt0; clear Hgetsa Hgetsa'.
  exists objs'; exists x0.
  split.
  unfold HpUnchangeInB, hget, uhset; stSimpl.
  intros x HxinB.
  assert (Hxin : set_In x objs).
  elimSetIn.
  subst objs.
  assert (Hptrx := in_rangeMsobj_ptrP _ _ x Hst Hed Hxin).
  assert (Hptrx' := succPtr Hptrx).
  clear H6 H7 HF H0 Hset_eq Hxin Hroot Hdiff Hphase Hswpt Hk.
  sconjLift2 Hp.
  assert (HptrNumfree := contElim1L Hp).
  sconjLift5 Hp.
  assert (HptrNewFreePtr := contElim1L Hp).
  sconjLift4 Hp.
  assert (HptrFreePtr2 := contElim1L Hp).
  sconjLift5 Hp.
  assert (HptrFreePtr := contElim1L Hp).
  assert (HptrFreePtrHd : ptrP (freePtr - 4)).
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR (sconjAssocR Hp))))))))))).
  sconjLift2 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  apply (contElim1L Hp).
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR (sconjAssocR Hp))))))))))).
  sconjLift5of5 Hp.
  assert (Hexfh : x <> freePtr - 4 /\ 4 + x <> freePtr - 4).
  sconjLift3 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  sconjLift3 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexfh as [Hexfhd Hexfhd'].
  linLogElim Hp.
  assert (Hexf : x <> freePtr /\ 4 + x <> freePtr).
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexf as [Hexfptr Hexfptr'].
  sconjLift3 Hp.
  sconjLift2 Hp.
  assert (Hexf2 : x <> 4 + freePtr /\ 4 + x <> 4 + freePtr).
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexf2 as [Hexfptr2 Hexfptr2'].
  assert (Hexfp : x <> 8 + rget s rgcInfo /\ 4 + x <> 8 + rget s rgcInfo).
  sconjLift4 Hp.
  sconjLift2 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexfp as [Hexnfp Hexnfp'].
  assert (Hexn : x <> 28 + rget s rgcInfo /\ 4 + x <> 28 + rget s rgcInfo).
  sconjLift5 Hp.
  sconjLift2 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexn as [Hexnf Hexnf'].
  clear Hp.
  destruct s; stSimpl.
  rewrite <- (HeapgetNeq _ _ h x0 Hptrx HptrNewFreePtr Hexnfp).
  rewrite <- (HeapgetNeq _ _ (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    NULL Hptrx HptrFreePtr Hexfptr).
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    freePtr NULL) NULL Hptrx HptrFreePtr2 Hexfptr2).
  rewrite <- (HeapgetNeq _ _ (Heap.uset
    (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0) freePtr
      NULL) (4 + freePtr) NULL) (numfree - 1) Hptrx HptrNumfree Hexnf).
  rewrite <- (HeapgetNeq _ _ h x0 Hptrx' HptrNewFreePtr Hexnfp').
  rewrite <- (HeapgetNeq _ _ (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    NULL Hptrx' HptrFreePtr Hexfptr').
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    freePtr NULL) NULL Hptrx' HptrFreePtr2 Hexfptr2').
  rewrite <- (HeapgetNeq _ _ (Heap.uset
    (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0) freePtr
      NULL) (4 + freePtr) NULL) (numfree - 1) Hptrx' HptrNumfree Hexnf').
  split; apply HeapgetNeq; trivial.

  unfold newSweepPost, isweepPre, isweepPreP; stSimpl.
  split; intro He.
  2: rewrite He in HF; elim HF; reflexivity.

  sconjLift4 Hp.
  sconjLift6 Hp.
  assert (Hfpnotinobjs' := ifreeList_cont_notIn _ _ _ _ _ _ Hp).
  assert (HfpnotinW : ~set_In freePtr W).
  intro HfpinW.
  sconjLiftH 14 Hp.
  hypReplace Hp (sconjAssocL (fasElimL HfpinW Hp)).
  unfold okObjAt, okFieldAt in Hp.
  linLogElim Hp.
  sconjLift6 Hp.
  apply (contContFalse Hp).
  repeat (split; trivial).
  intro HfpInB.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR (sconjAssocR Hp)))))))))).
  sconjLift6of6 Hp.
  linLogElim Hp.
  sconjLift3 Hp.
  sconjLift2 Hp.
  destruct (objHp_cont_neq _ _ _ _ _ _ _ HfpInB Hp) as [Hn _].
  apply Hn; trivial.
  destruct Hroot; [left; trivial | right; elimSetIn].
  subst numfree.
  rewrite <- (notInPlus' objs' freePtr Hfpnotinobjs').
  auto with arith.
  intro; elimSetIn.
  intro.
  destruct (Hset_eq a) as [_ HI].
  hypReplace HI (HI H).
  elimSetIn.
  unfold uhset; stSimpl.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR  Hp)))))))).
  sconjLift5 Hp.
  hypReplace Hp (sconjAssocL (fasElimL Hfpin Hp)).
  hypReplace Hp (contUpdateSt Hp MARKED).
  sconjLift2 Hp.
  apply sconjGLift2'.
  apply (sconjImpl Hp); clear Hp; intros h Hp.
  rewrite hpredTrueEq.
  setoid_replace (W |_| objs') with
    (set_remove freePtr (W |_| freePtr :: objs')).
  split; intro; elimSetIn.
  elim H1; reflexivity.
  assumption.
  sconjLift6 Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift6 Hp.
  apply sconjGLift3'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift5 Hp.
  apply (sconjImpl (sconjAssocR Hp)); clear h Hp; intros h Hp.
  apply (bobjHdrsIntro1 _ _ _ _ _ _ Hge (sconjComm Hp)).
  smartAssocL Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  linLogIntro.
  sconjLift4 Hp.
  hypReplace Hp (sconjAssocR Hp).
  sconjLift3 Hp.
  sconjLift3 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift8 Hp.
  sconjLift9 Hp.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  apply aconjIntro1.
  apply objHpIntro.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2 : apply (sconjComm Hp).
  left; unfold atomP; auto with arith.
  left; unfold atomP; auto with arith.
  unfold objHp.
  apply (fasImpl Hp).
  unfold okObjAt, okFieldAt.
  clear h Hp; intros.
  linLogElim H.
  linLogIntro.
  2: apply H.
  destruct H5; [left; trivial | right; elimSetIn].
  destruct H8; [left; trivial | right; elimSetIn].
  
  clear Hgetfp Hgetnf HgetNfp Hgetsa Hphase H6.
  split; trivial.
  intros.
  stSimpl.
  trivial.

  (* IDLE_PHASE *)
  destruct Hpre as [B [free [objs [ohpSt [ohpEnd [freePtr 
    [stBot [stBuff [numfree [Hroot [Hnumfree [_ [Hst [Hed
      [Hobjs [Hset_eq Hp]]]]]]]]]]]]]]]].

  sconjLift3 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  rewrite (lwStep Hp); trivial.
  assert (Hgetfp := contGetEqL Hp).
  rewrite addiuStepZero; stSimpl.
  doBtestSimpl.

  (* IDLE_PHASE /\ freePtr = NULL / free = empty_set *)
  unfold return0Pre, return0Guar.
  split; trivial.
  clear B free objs ohpSt ohpEnd stBot stBuff numfree Hst Hed
    Hobjs Hset_eq Hp Hroot Hnumfree.

  intros.
  right; right.
  split; trivial.
  subst s'.
  split.
  intros.
  destruct H as [Hroot [Hnumfree [_ [Hst [Hed [Hobjs
    [Hset_eq Hp]]]]]]].
  assert (Hpt := Hp).
  sconjLift3 Hpt.
  unfold contL in Hpt.
  smartAssocL Hpt; sconjLift2 Hpt.
  smartAssocL Hpt; sconjLift2 Hpt.
  smartAssocL Hpt.
  assert (Hgetfp' := contGetEqL Hpt).
  rewrite Hgetfp' in Hgetfp; inversion Hgetfp.
  subst freePtr0; clear Hpt Hgetfp' Hgetfp.
  unfold newIdlePost, HpUnchangeInB, hget; stSimpl.
  
  exists empty_set; exists NULL.
  split; auto.
  split; intro He.
  sconjLift4 Hp.
  subst freePtr.
  assert (Ht := ifreeList_NULL_empty _ _ _ Hp).
  rewrite Ht in He; elim He; reflexivity.
  repeat (split; auto).
  split; trivial.
  intros; stSimpl; trivial.

  (* IDLE_PHASE /\ freePtr <> NULL / free <> empty_set *)
  sconjLift7 Hp.
  assert (HF : free <> empty_set).
  intro He; subst free.
  assert (Bt' := ifreeList_empty_NULL _ freePtr _ Hp).
  apply Bt; auto.
  destruct (notEmptyIsCons HF) as [x [objs' Hobjs']].
  subst free.
  assert (Hfpin : set_In freePtr (B |_| freePtr :: objs')).
  elimSetIn.
  unfold ifreeList in Hp.
  fold ifreeList in Hp.
  linLogElim Hp.
  subst x.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (HgetNfp := contGetEqL Hp).
  sconjLift4 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp x0).
  rewrite addiuStepZero.
  sconjLift2 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift3 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift9 Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (Hgetnf := contGetEqL Hp).
  rewrite addiuStepZero; stSimpl.
  rewrite subuStep; stSimpl.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp (numfree - 1)).
  rewrite addiuStepZero; stSimpl.
  rewrite Hphase.
  unfold doBtest, negb.
  rewrite beq_true; trivial.
  unfold return0Pre, return0Guar.
  split; trivial.
  clear Hp Hfpin HF Hset_eq Hnumfree objs' Bt Hobjs Hed Hst Hroot
    stBuff stBot ohpSt ohpEnd objs B.

  intros s' H.
  subst s'.
  right; right.
  split; trivial.
  split.
  intros.
  destruct H as [Hroot [Hnumfree [_ [Hst [Hed [Hobjs
    [Hset_eq Hp]]]]]]].
  aconjE2 Hp.
  clear Hp; rename Hh into Hp.
  sconjLift3 Hp.
  unfold contL in Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp; sconjLift2 Hp.
  smartAssocL Hp.
  assert (Hgetfp' := contGetEqL Hp).
  rewrite Hgetfp' in Hgetfp; inversion Hgetfp.
  subst freePtr0; clear Hgetfp Hgetfp'.
  sconjLift7 Hp.
  assert (HF : free <> empty_set).
  intro He; subst free.
  assert (Bt := ifreeList_empty_NULL _ freePtr _ Hp).
  apply H6; auto.
  destruct (notEmptyIsCons HF) as [x [objs' Hobjs']].
  subst free.
  assert (Hfpin : set_In freePtr (B |_| freePtr :: objs')).
  elimSetIn.
  unfold ifreeList in Hp.
  fold ifreeList in Hp.
  linLogElim Hp.
  subst x.
  assert (HgetNfp' := contGetEqL Hp).
  rewrite HgetNfp' in HgetNfp; inversion HgetNfp.
  subst x1; clear HgetNfp HgetNfp'.
  sconjLift4 Hp.
  hypReplace Hp (contUpdateSt Hp x0).
  sconjLift2 Hp.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift3 Hp.
  hypReplace Hp (contUpdateSt Hp NULL).
  sconjLift9 Hp.
  assert (Hgetnf' := contGetEqL Hp).
  rewrite Hgetnf' in Hgetnf; inversion Hgetnf.
  subst numfree0; clear Hgetnf' Hgetnf.
  hypReplace Hp (contUpdateSt Hp (numfree - 1)).
  exists objs'; exists x0.
  split.
  unfold HpUnchangeInB, hget, uhset; stSimpl.
  intros x HxinB.
  assert (Hxin : set_In x objs).
  elimSetIn.
  subst objs.
  assert (Hptrx := in_rangeMsobj_ptrP _ _ x Hst Hed Hxin).
  assert (Hptrx' := succPtr Hptrx).
  clear H6 H7 HF H0 Hset_eq Hxin Hroot.
  assert (HptrNumfree := contElim1L Hp).
  sconjLift4 Hp.
  assert (HptrNewFreePtr := contElim1L Hp).
  sconjLift3 Hp.
  assert (HptrFreePtr2 := contElim1L Hp).
  sconjLift4 Hp.
  assert (HptrFreePtr := contElim1L Hp).
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR Hp)))))))))).
  sconjLift4of4 Hp.
  linLogElim Hp.
  assert (Hexf : x <> freePtr /\ 4 + x <> freePtr).
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexf as [Hexfptr Hexfptr'].
  sconjLift3 Hp.
  sconjLift2 Hp.
  assert (Hexf2 : x <> 4 + freePtr /\ 4 + x <> 4 + freePtr).
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexf2 as [Hexfptr2 Hexfptr2'].
  assert (Hexfp : x <> 8 + rget s rgcInfo /\ 4 + x <> 8 + rget s rgcInfo).
  sconjLift4 Hp.
  sconjLift2 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexfp as [Hexnfp Hexnfp'].
  assert (Hexn : x <> 28 + rget s rgcInfo /\ 4 + x <> 28 + rget s rgcInfo).
  sconjLift5 Hp.
  sconjLift2 Hp.
  apply (objHp_cont_neq _ _ _ _ _ _ _ HxinB Hp).
  destruct Hexn as [Hexnf Hexnf'].
  clear Hp.
  destruct s; stSimpl.
  rewrite <- (HeapgetNeq _ _ h x0 Hptrx HptrNewFreePtr Hexnfp).
  rewrite <- (HeapgetNeq _ _ (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    NULL Hptrx HptrFreePtr Hexfptr).
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    freePtr NULL) NULL Hptrx HptrFreePtr2 Hexfptr2).
  rewrite <- (HeapgetNeq _ _ h x0 Hptrx' HptrNewFreePtr Hexnfp').
  rewrite <- (HeapgetNeq _ _ (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    NULL Hptrx' HptrFreePtr Hexfptr').
  rewrite <- (HeapgetNeq _ _ (Heap.uset (Heap.uset h (4 + (4 + rget (h, r) rgcInfo)) x0)
    freePtr NULL) NULL Hptrx' HptrFreePtr2 Hexfptr2').
  split; apply HeapgetNeq; trivial.

  unfold newIdlePost, imarkSweepGCInitPreP; stSimpl.
  split; intro He.
  2: rewrite He in HF; elim HF; reflexivity.

  sconjLift3 Hp.
  sconjLift5 Hp.
  assert (Hfpnotinobjs' := ifreeList_cont_notIn _ _ _ _ _ _ Hp).
  assert (HfpnotinB : ~set_In freePtr B).
  intro HfpinB.
  sconjLiftH 13 Hp.
  hypReplace Hp (sconjAssocL (fasElimL HfpinB Hp)).
  unfold okObjAt, okFieldAt in Hp.
  linLogElim Hp.
  sconjLift5 Hp.
  apply (contContFalse Hp).
  repeat (split; trivial).
  destruct Hroot; [left; trivial | right; elimSetIn].
  subst numfree.
  rewrite <- (notInPlus' objs' freePtr Hfpnotinobjs').
  auto with arith.
  intro; elimSetIn.
  intro.
  destruct (Hset_eq a) as [_ HI].
  hypReplace HI (HI H).
  elimSetIn.
  unfold uhset; stSimpl.
  hypReplace Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR 
    (sconjAssocR (sconjAssocR (sconjAssocR  Hp)))))))).
  sconjLift4 Hp.
  apply (sconjImpl Hp); clear Hp; intros h Hp.
  rewrite hpredTrueEq.
  setoid_replace (set_add freePtr B |_| objs') with
    (B |_| freePtr :: objs').
  split; intro; elimSetIn.
  assumption.
  sconjLift4 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  linLogElim Hp.
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift3 Hp.
  hypReplace Hp (sconjAssocR Hp).
  sconjLift2 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift7 Hp.
  sconjLift8 Hp.
  sconjLift9 Hp.
  unfold contL.
  linLogIntro.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  apply aconjIntro1.
  apply objHpIntro.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold okObjAt, okFieldAt.
  linLogIntro.
  2 : apply (sconjComm Hp).
  left; unfold atomP; auto with arith.
  left; unfold atomP; auto with arith.
  unfold objHp.
  apply (fasImpl Hp).
  unfold okObjAt, okFieldAt.
  clear h Hp; intros.
  linLogElim H.
  linLogIntro.
  2: apply H.
  destruct H5; [left; trivial | right; elimSetIn].
  destruct H8; [left; trivial | right; elimSetIn].
  
  clear Hgetfp Hgetnf HgetNfp Hphase H6.
  split; trivial.
  intros.
  stSimpl.
  trivial.
Qed.

Theorem imarkSweepNewImplOk :
  iseqOkS imarkSweepNewObjP newObjPre newObjGuar newObjGCImpl.
Proof.
  unfold newObjGCImpl.
  iseqWeakSolver PsimplimarkSweepNewObj.
  
  intros s s' Hpre HG.
  destruct Hpre as [[Hphase Hpre] | [[Hphase Hpre] | [Hphase Hpre]]]. 
  destruct HG as [[_ [_ [Hcall _]]] | [[Hphase' _] | [Hphase' _]]].
  2: rewrite Hphase' in Hphase; inversion Hphase.
  2: rewrite Hphase' in Hphase; inversion Hphase.
  apply Hcall.
  left; reflexivity.

  destruct HG as [[Hphase' _] | [[_ [_ [Hcall _]]] | [Hphase' _]]].
  rewrite Hphase' in Hphase; inversion Hphase.
  2: rewrite Hphase' in Hphase; inversion Hphase.
  apply Hcall.
  left; reflexivity.

  destruct HG as [[Hphase' _] | [[Hphase' _] | [_ [_ [Hcall _]]]]].
  rewrite Hphase' in Hphase; inversion Hphase.
  rewrite Hphase' in Hphase; inversion Hphase.
  apply Hcall.
  left; reflexivity.

  unfold newObjPre, imarkSweepGCPre.
  intros s Hpre.

  rewrite addiuStep0; stSimpl.
  split.
  split.
  apply Hpre.

  intros s' HG.
  destruct Hpre as [[Hphase HMpre] | [[Hphase HSpre] | [Hphase HIpre]]].
  destruct HG as [HGM | [[Hphase' _] | [Hphase' _]]].
  2: generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  2: generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  generalize HGM; unfold imarkPreP; stSimpl; clear HGM; intro HGM.
  destruct HGM as [_ [Hgm _]].
  destruct HMpre as [B [G [W [free [objs [ohpSt [ohpEnd [freePtr [stBot [stBuff 
    [stTop [numfree Hpre]]]]]]]]]]]].
  hypReplace Hgm (Hgm _ _ _ _ _ _ _ _ _ _ _ _ _ Hpre); clear Hpre.
  destruct Hgm as [sum [stTop' [B' [G' [W' [HpInv [Hpost Hsum]]]]]]].
  destruct Hpost as [Hroot [Hnumfree [Hswpsum [Hphase' [Hst [Hed [Hobjs
    [Hset_eq Hp]]]]]]]].
  destruct Hphase' as [[Hmphase [Htop Gset]] | [Hsphase [Htop Gset]]].
  left.
  split; trivial.
  exists B'; exists G'; exists W'; exists free; exists objs; exists ohpSt;
    exists ohpEnd; exists freePtr; exists stBot; exists stBuff; exists stTop';
      exists numfree.
  repeat (split; trivial).
  
  right; left.
  split; trivial.
  subst G'.
  exists B'; exists W'; exists objs; exists free; exists empty_set;
    exists ohpSt; exists ohpEnd; exists freePtr; exists stBot; 
      exists stBuff; exists ohpSt; exists numfree.
  rewrite <- (set_unionEmpty B') in Hroot.
  rewrite <- (set_unionEmpty B') in Hset_eq.
  rewrite <- (set_unionEmpty B') in Hp.
  subst stTop'.
  repeat (split; trivial).
  apply set_diffUnit.
  unfold rangeMSObjs, setZeroRange.
  replace (div12 (11 + ohpSt - ohpSt)) with O.
  reflexivity.
  replace (11 + ohpSt - ohpSt) with 11.
  compute; reflexivity.
  omega.
  exists 0.
  replace (12 * 0) with 0.
  trivial.
  compute; reflexivity.
  hypReplace Hp (sconjAssocR Hp).
  apply (sconjImpl Hp); clear HpInv Hp; intros h Hp.
  unfold objHdrs, fas in Hp.
  simpl in Hp.
  hypReplace Hp (unitER Hp).
  eapply bobjHdrsIntroGe.
  2: apply Hp.
  intros x HinB.
  assert (Hin : set_In x objs).
  elimSetIn.
  subst objs.
  destruct (rangeMSObjsElim _ _ _ Hin) as [_ [k He]].
  omega.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  rewrite <- (set_unionEmptyL W') in Hp.
  hypReplace Hp (aconjER Hp).
  apply (sconjImpl (sconjComm Hp)).
  unfold objHp; clear h Hp; intros h Hp.
  apply (fasImpl Hp); clear h Hp.
  unfold okObjAt, okFieldAt.
  intros.
  linLogElim H.
  linLogIntro.
  2: apply H.
  destruct H4; [left; trivial | right; elimSetIn].
  destruct H5; [left; trivial | right; elimSetIn].
  clear h Hp; intros h Hp.
  apply aconjIntro.
  linLogIntro.
  apply Hp.
  
  destruct HG as [[Hphase' _] | [HGS | [Hphase' _]]].
  generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  2: generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  
  generalize HGS; unfold isweepPreP; stSimpl; clear HGS; intro HGS.
  destruct HGS as [_ [Hgs _]].
  destruct HSpre as [B [W [objs [free [swept [ohpSt [ohpEnd [freePtr [stBot [stBuff 
    [sweepAt [numfree Hpre]]]]]]]]]]]].
  hypReplace Hgs (Hgs _ _ _ _ _ _ _ _ _ _ _ _ _ Hpre); clear Hpre.
  destruct Hgs as [sum [W' [free' [swept' [freePtr' [sweepAt'
    [numfree' [HpInv [Hpost Hsum]]]]]]]]].
  destruct Hpost as [Hroot [Hswpsum [Hnumfree [Hst [Hed [Hdiff 
    [Hobjs [Hswpt [Hk [Hset_eq [Hphase' Hp]]]]]]]]]]].
  destruct Hphase' as [[Hiphase [HswpAt [SWA WSET]]] | [Hsphase [HswpAt SWA]]].
  right; right.
  split; trivial.
  exists B; exists free'; exists objs; exists ohpSt; exists ohpEnd;
    exists freePtr'; exists stBot; exists stBuff; exists numfree'.
  subst sweepAt'; subst W'.
  rewrite <- (set_unionEmpty B) in Hset_eq.
  repeat (split; trivial).
  sconjLift5 Hp.
  unfold objHp, fas in Hp.
  set (GCINFO := rget s' rgcInfo |->, (ohpSt :: ohpEnd :: freePtr' :: stBot
    :: stBuff :: stBot :: ohpSt :: numfree' :: nil)) in * .
  simpl in Hp.
  hypReplace Hp (unitEL Hp).
  hypReplace Hp (sconjAssocR Hp).
  apply (sconjImplL Hp); clear Hp GCINFO HpInv; intros h Hp.
  apply objHdrsMerge.
  apply (sconjImplL Hp); clear h Hp; intros h Hp.
  eapply bobjHdrsElim.
  2: apply Hp.
  intros x HinB.
  assert (Hin : set_In x objs).
  elimSetIn.
  subst objs.
  destruct (rangeMSObjsElim _ _ _ Hin) as [He _].
  omega.

  right; left.
  split; trivial.
  exists B; exists W'; exists objs; exists free'; exists swept';
    exists ohpSt; exists ohpEnd; exists freePtr'; exists stBot; 
      exists stBuff; exists sweepAt'; exists numfree'.
  subst sweepAt'.
  repeat (split; trivial).

  destruct HG as [[Hphase' _] | [[Hphase' _] | HGI]].
  generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.

  
  generalize HGI; unfold imarkSweepGCInitGuar, imarkSweepGCInitPreP; stSimpl; 
    clear HGI; intro HGI.
  destruct HGI as [_ [Hgi _]].
  destruct HIpre as [B [free [objs [ohpSt [ohpEnd [freePtr [stBot [stBuff 
    [numfree Hpre]]]]]]]]].
  hypReplace Hgi (Hgi _ _ _ _ _ _ _ _ _ _ Hpre); clear Hpre.
  destruct (le_lt_dec 10 numfree) as [GE | LT].
  destruct Hgi as [_ Hgi].
  destruct (Hgi GE) as [HpInv Hpost]; clear Hgi.
  destruct Hpost as [Hroot [Hnumfree [Hphase' [Hst [Hed [Hobjs [Hset_eq Hp]]]]]]].
 
  right; right.
  split; trivial.
  exists B; exists free; exists objs; exists ohpSt; exists ohpEnd;
    exists freePtr; exists stBot; exists stBuff; exists numfree.
  repeat (split; trivial).

  destruct Hgi as [Hgi _].
  destruct (Hgi LT) as [HpInv Hpost]; clear Hgi.
  destruct Hpost as [G [W [stTop [Hroot [Hnumfree [Hphase' [Hst [Hed
    [Hobjs [Hset_eq Hp]]]]]]]]]].
 
  left.
  split; trivial.
  unfold imarkPre, imarkPreP.
  exists empty_set; exists G; exists W; exists free; exists objs;
    exists ohpSt; exists ohpEnd; exists freePtr; exists stBot;
      exists stBuff; exists stTop; exists numfree.
  repeat (split; trivial).
  
  (* MARK_PHASE *)
  destruct Hpre as [[Hphase _] | [[Hphase _] | [Hphase _]]].
  intros s'' [s' [HGgc HGnew]].
  left.
  split; trivial.
  destruct HGgc as [HGgc | [[Hphase' _] | [Hphase' _]]].
  2: generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  2: generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.

  split.
  intros.
  generalize HGgc; unfold imarkPreP, HpUnchangeNotInF, hget; stSimpl;
    clear HGgc; intro HGgc.
  destruct HGgc as [_ [Hgm _]].
  hypReplace Hgm (Hgm _ _ _ _ _ _ _ _ _ _ _ _ _ H).
  destruct Hgm as [sum [stTop' [B' [G' [W' [HpInv [Hpost Hsum]]]]]]].
  destruct Hpost as [Hroot [Hnumfree [Hswpsum [Hphase' [Hst [Hed [Hobjs
    [Hset_eq Hp]]]]]]]].
  destruct Hphase' as [[Hmphase [Htop Gset]] | [Hsphase [Htop Gset]]].
  left.
  (* MARK_PHASE /\ MARK_PHASE' *)
  destruct HGnew as [[_ HGnew] | [[Hphase' _] | [Hphase' _]]].
  2: rewrite Hphase' in Hmphase; inversion Hmphase.
  2: rewrite Hphase' in Hmphase; inversion Hmphase.
  destruct HGnew as [HGnew _].
  assert (Hpre' : imarkPreP s' B' G' W' free objs ohpSt ohpEnd freePtr stBot
    stBuff stTop' numfree (objHp (B' |_| G') B' ** objHp ((B' |_| G') |_| W') (G' |_| W'))).
  repeat (split; trivial).
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  hypReplace Hp (aconjER Hp).
  apply aconjIntro; assumption.
  hypReplace HGnew (HGnew _ _ _ _ _ _ _ _ _ _ _ _ Hpre'); clear Hpre'.
  destruct HGnew as [free' [freePtr' [HpInv' Hpost]]].
  exists stTop'; exists B'; exists G'; exists W'; exists free';
    exists freePtr'.
  split; trivial.
  clear Hp Hset_eq Hobjs Hst Hed Gset Htop Hroot Hpost Hsum.
  intros x Hset.
  destruct (HpInv x Hset) as [GL GR].
  rewrite <- GL; rewrite <- GR.
  unfold HpUnchangeNotInF, hget in HpInv'.
  apply HpInv'; trivial.
  
  right.
  destruct HGnew as [[Hphase' _] | [[_ HGnew] | [Hphase' _]]].
  rewrite Hphase' in Hsphase; inversion Hsphase.
  2: rewrite Hphase' in Hsphase; inversion Hsphase.
  (* MARK_PHASE /\ SWEEP_PHASE' *)
  destruct HGnew as [HGnew _].
  subst G'; subst stTop'.
  rewrite <- (set_unionEmpty B') in Hroot.
  rewrite <- (set_unionEmpty B') in Hset_eq.
  rewrite <- (set_unionEmptyL W') in Hp.
  rewrite <- (set_unionEmpty B') in Hp.
  assert (Hpre' : isweepPreP s' B' W' objs free empty_set ohpSt ohpEnd freePtr stBot
    stBuff ohpSt numfree (objHp B' B')).
  repeat (split; trivial).
  apply set_diffUnit.
  unfold rangeMSObjs, setZeroRange.
  replace (div12 (11 + ohpSt - ohpSt)) with O.
  reflexivity.
  replace (11 + ohpSt - ohpSt) with 11.
  compute; reflexivity.
  omega.
  exists 0.
  replace (12 * 0) with 0.
  trivial.
  compute; reflexivity.
  hypReplace Hp (sconjAssocR Hp).
  apply (sconjImpl Hp); clear HpInv Hsum Hp HGnew; intros h Hp.
  unfold objHdrs, fas in Hp.
  simpl in Hp.
  hypReplace Hp (unitER Hp).
  eapply bobjHdrsIntroGe.
  2: apply Hp.
  intros x HinB.
  assert (Hin : set_In x objs).
  elimSetIn.
  subst objs.
  destruct (rangeMSObjsElim _ _ _ Hin) as [_ [k He]].
  omega.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  apply sconjGLift2'.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  hypReplace Hp (aconjER Hp).
  apply (sconjImpl (sconjComm Hp)).
  unfold objHp.
  apply fasImpl0.
  unfold okObjAt, okFieldAt.
  clear h Hp.
  intros x h Hp.
  linLogElim Hp.
  linLogIntro.
  2: apply Hp.
  destruct H4; [left; trivial | right; elimSetIn].
  destruct H5; [left; trivial | right; elimSetIn].
  clear h Hp; intros h Hp.
  apply aconjIntro; assumption.
  hypReplace HGnew (HGnew _ _ _ _ _ _ _ _ _ _ _ _ Hpre'); clear Hpre'.
  destruct HGnew as [free' [freePtr' [HpInv' Hpost]]].
  assert (BGW_disj_F : set_disj ((B |_| G) |_| W) free).
  clear Hp Hpost Hphase Hnumfree Hswpsum Hsphase Hst Hed 
    Hobjs Hsum Hroot HpInv HpInv' Hset_eq.
  destruct H as [_ [_ [_ [_ [_ [Hobjs [Hset_eqv Hp]]]]]]].
  aconjE2 Hp.
  clear Hp; rename Hh into Hp.
  setoid_rewrite (set_eqvUnionAssoc B G W).
  sconjLift8of8 Hp; sconjLift8of8 Hp; sconjLift8of8 Hp.
  eapply objHp_ifreelist_disj_union; eauto.
  intros x Hin.
  elimSetIn.
  intros x Hin.
  elimSetIn.
  exists B'; exists W'; exists free'; exists freePtr'.
  split; trivial.
  assert (B'W'_disj_F : set_disj (B' |_| W') free).
  clear Hpost Hphase Hnumfree Hswpsum Hsphase Hst Hed 
    Hsum Hroot H HpInv HpInv'.
  aconjE2 Hp.
  clear Hp; rename Hh into Hp.
  sconjLift8of8 Hp; sconjLift8of8 Hp; sconjLift8of8 Hp.
  eapply objHp_ifreelist_disj_union; eauto.
  intros x Hin.
  elimSetIn.
  intros x Hin.
  elimSetIn.
  clear Hp Hpost Hphase Hnumfree Hswpsum Hsphase Hst Hed 
    Hobjs Hsum Hroot.
  destruct H as [_ [_ [_ [_ [_ [_ [Hset_eqv Hp]]]]]]].
  unfold HpUnchangeInB, hget in * .
  intros.
  destruct (HpInv' x H) as [GL GR].
  rewrite GL; rewrite GR; clear HpInv' GL GR.
  apply HpInv; clear HpInv.
  assert (Hin : set_In x (B' |_| W')).
  elimSetIn.
  assert (He : set_eqv ((B |_| G) |_| W) (B' |_| W')).
  apply unionDisjEqv with free; trivial.
  setoid_rewrite Hset_eq; assumption.
  assert (Hin' : set_In x ((B |_| G) |_| W)).
  elimSetIn.
  split.
  elimSetIn.
  intro HinF.
  apply set_disj_elim with ((B |_| G) |_| W) free x; trivial.
  
  destruct HGgc as [_ [_ [Hcall Hcst0]]].
  assert (Hr : (forall r, r <> v0 -> r <> ra -> r <> rtemp -> r <> rnumfree ->
    rget s'' r = rget s' r) /\ rget s' rcst0 = rget s'' ra).
  destruct HGnew as [[_ [_ HG]] | [[_ [_ HG]] | [_ [_ HG]]]]; assumption.
  destruct Hr as [Hr Hra'']; clear HGnew.
  apply raAndOthers.
  apply calleeSavedOkTrans' with s'.
  generalize Hcall; clear Hcall.
  unfold calleeSavedOk, regPres, calleeSaved, regInList.
  intros Hrr.
  intros r HcalleeSav'.
  destruct HcalleeSav' as [H | [H | [H | [H | [
    H | [H | [H | [H | H]]]]]]]];
  try (subst r; rewrite <- Hrr; intuition).
  elim H.
  clear Hcall.
  intros r HcalleeSav'.
  destruct HcalleeSav' as [H | [H | [H | [H | [
    H | [H | [H | [H | H]]]]]]]];
  try (subst r;regEqSolver).
  elim H.
  rewrite <- Hra''; assumption.

  (* SWEEP_PHASE *)
  intros s'' [s' [HGgc HGnew]].
  right; left.
  split; trivial.

  destruct HGgc as [[Hphase' _] | [[_ HGgc] | [Hphase' _]]].
  generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  2: generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.

  split.
  intros.
  generalize HGgc; unfold isweepPreP, HpUnchangeInB, hget; stSimpl;
    clear HGgc; intro HGgc.
  destruct HGgc as [Hgs _].
  hypReplace Hgs (Hgs _ _ _ _ _ _ _ _ _ _ _ _ _ H); clear H.
  destruct Hgs as [num [W' [free' [swept' [freePtr' [sweepAt' [numfree' 
    [HpInv [Hpost [HswpAt Henum]]]]]]]]]].
  destruct Hpost as [Hroot [Hswpsum [Hnumfree [Hst [Hed [Hdiff [Hobjs
    [Hswept [Hk [Hset_eq [Hphase' Hp]]]]]]]]]]].
  destruct Hphase' as [[Hiphase [HeswpAt [HswpAt' Wset]]] | [Hsphase [HeswpAt HswpAt']]].
  destruct HGnew as [[Hphase' _] | [[Hphase' _] | [_ HGnew]]].
  rewrite Hphase' in Hiphase; inversion Hiphase.
  rewrite Hphase' in Hiphase; inversion Hiphase.
  (* SWEEP_PHASE  /\ IDLE_PHASE' *)
  right.
  destruct HGnew as [HGnew _].
  subst W'; subst sweepAt'.
  rewrite <- (set_unionEmpty B) in Hset_eq.
  rewrite <- (set_unionEmptyL free') in Hp.
  assert (Hpre' : imarkSweepGCInitPreP s' B free' objs ohpSt ohpEnd freePtr'
    stBot stBuff numfree' (objHp B B)).
  repeat (split; trivial).
  apply (sconjImpl (sconjAssocR Hp)); clear Hp HGnew HpInv 
    Hdiff; intros h Hp.
  apply objHdrsMerge.
  apply (sconjImplL Hp); clear h Hp; intros h Hp.
  eapply bobjHdrsElim.
  2 : apply Hp.
  intros x HxinB.
  assert (Hxin : set_In x objs).
  elimSetIn.
  subst objs.
  destruct (rangeMSObjsElim _ _ _ Hxin) as [He _].
  omega.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift2 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  unfold objHp, fas in Hp; simpl in Hp.
  hypReplace Hp (unitEL Hp).
  apply Hp.
  hypReplace HGnew (HGnew _ _ _ _ _ _ _ _ _ Hpre'); clear Hpre'.
  destruct HGnew as [free'' [freePtr'' [HpInv' Hpost]]].
  exists free'; exists freePtr'; exists numfree'; exists free'';
    exists freePtr''.
  split; trivial.
  clear Hpost Hp Hset_eq Hk Hswept Hobjs Hst Hed Hroot Hdiff Henum HeswpAt.
  intros x HxinB.
  destruct (HpInv x HxinB) as [GL GR].
  rewrite <- GL; rewrite <- GR.
  unfold HpUnchangeInB, hget in HpInv'.
  apply HpInv'; trivial.
  (* SWEEP_PHASE /\ SWEEP_PHASE' *)
  left.
  destruct HGnew as [[Hphase' _] | [[_ HGnew] | [Hphase' _]]].
  rewrite Hphase' in Hsphase; inversion Hsphase.
  2 : rewrite Hphase' in Hsphase; inversion Hsphase.
  destruct HGnew as [HGnew _].
  assert (Hpre' : isweepPreP s' B W' objs free' swept' ohpSt ohpEnd freePtr'
    stBot stBuff sweepAt' numfree' (objHp B B)).
  subst sweepAt'.
  repeat (split; trivial).
  hypReplace HGnew (HGnew _ _ _ _ _ _ _ _ _ _ _ _ Hpre'); clear Hpre'.
  destruct HGnew as [free'' [freePtr'' [HpInv' Hpost]]].
  exists W'; exists free'; exists swept'; exists freePtr'; exists sweepAt';
    exists numfree'; exists free''; exists freePtr''.
  split; trivial.
  clear Hp Hpost HswpAt Henum Hroot Hswpsum Hnumfree Hst Hed Hdiff Hobjs Hk Hswept.
  intros x HxinB.
  destruct (HpInv x HxinB) as [GL GR].
  rewrite <- GL; rewrite <- GR.
  unfold HpUnchangeInB, hget in HpInv'.
  apply HpInv'; trivial.

  destruct HGgc as [_ [Hcall Hcst0]].
  assert (Hr : (forall r, r <> v0 -> r <> ra -> r <> rtemp -> r <> rnumfree ->
    rget s'' r = rget s' r) /\ rget s' rcst0 = rget s'' ra).
  destruct HGnew as [[_ [_ HG]] | [[_ [_ HG]] | [_ [_ HG]]]]; assumption.
  destruct Hr as [Hr Hra'']; clear HGnew.
  apply raAndOthers.
  apply calleeSavedOkTrans' with s'.
  generalize Hcall; clear Hcall.
  unfold calleeSavedOk, regPres, calleeSaved, regInList.
  intros Hrr.
  intros r HcalleeSav'.
  destruct HcalleeSav' as [H | [H | [H | [H | [
    H | [H | [H | [H | H]]]]]]]];
  try (subst r; rewrite <- Hrr; intuition).
  elim H.
  clear Hcall.
  intros r HcalleeSav'.
  destruct HcalleeSav' as [H | [H | [H | [H | [
    H | [H | [H | [H | H]]]]]]]];
  try (subst r;regEqSolver).
  elim H.
  rewrite <- Hra''; assumption.

  (* IDLE_PHASE *)
  intros s'' [s' [HGgc HGnew]].
  right; right.
  split; trivial.

  destruct HGgc as [[Hphase' _] | [[Hphase' _] | [_ HGgc]]].
  generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  generalize Hphase'; stSimpl; intro H;
    rewrite Hphase in H; inversion H.
  
  split.
  intros.
  generalize HGgc; unfold imarkSweepGCInitGuar, HpUnchangeInB, hget; stSimpl;
    clear HGgc; intro HGgc.
  destruct HGgc as [Hgi _].
  hypReplace Hgi (Hgi _ _ _ _ _ _ _ _ _ _ H).
  destruct (le_lt_dec 10 numfree) as [GE | LT].
  destruct Hgi as [_ Hgi]; clear H.
  hypReplace Hgi (Hgi GE).
  destruct Hgi as [HpInv Hpre'].
  assert (H := Hpre').
  destruct H as [_ [_ [Hiphase _]]].
  destruct HGnew as [[Hphase' _] | [[Hphase' _] | [_ HGnew]]].
  rewrite Hphase' in Hiphase; inversion Hiphase.
  rewrite Hphase' in Hiphase; inversion Hiphase.
  destruct HGnew as [HGnew _].
  hypReplace HGnew (HGnew _ _ _ _ _ _ _ _ _ Hpre').
  destruct Hpre' as [_ [Hnumfree _]].
  assert (HF : free <> empty_set).
  intro Hf.
  subst free.
  unfold set_card in Hnumfree.
  simpl in Hnumfree.
  subst numfree.
  assert (Ht := le_n_O_eq _ GE).
  inversion Ht.
  (* IDLE_PHASE /\ IDLE_PHASE' *)
  split; intro He.
  elimtype False; apply (lt_irrefl numfree).
  apply (lt_le_trans _ _ _ He GE).
  destruct HGnew as [free' [freePtr' [HpInv' Hpost]]].
  split.
  intros x HxinB.
  destruct (HpInv x HxinB) as [GL GR].
  rewrite <- GL; rewrite <- GR.
  unfold HpUnchangeInB, hget in HpInv'.
  apply HpInv'; trivial.
  exists freePtr'; exists free'.
  destruct Hpost as [Hpost _].
  hypReplace Hpost (Hpost HF).
  assumption.
  (* IDLE_PHASE /\ MARK_PHASE' *)
  destruct Hgi as [Hgm _].
  hypReplace Hgm (Hgm LT).
  destruct Hgm as [HpInv [G [W [stTop Hpre']]]].
  assert (Ht := Hpre').
  destruct Ht as [_ [_ [Hmphase _]]].
  destruct HGnew as [[_ HGnew] | [[Hphase' _] | [Hphase' _]]]. 
  2 : rewrite Hphase' in Hmphase; inversion Hmphase.
  2 : rewrite Hphase' in Hmphase; inversion Hmphase.
  destruct HGnew as [HGnew _].
(*  assert (Hpre : imarkPreP s' empty_set (set_add (rget s rroot) empty_set)
    (set_remove (rget s rroot) B) free objs ohpSt ohpEnd freePtr
    stBot stBuff stTop numfree (objHp (empty_set |_| set_add (rget s rroot) empty_set) empty_set **
    objHp ((empty_set |_| set_add (rget s rroot) empty_set) |_| set_remove (rget s rroot) B) 
    (set_add (rget s rroot) empty_set |_| set_remove (rget s rroot) B))).
  destruct Hpre' as [Hroot [Hnumfree [_ [Hst [Hed [Hobjs [Hset_eq Hp]]]]]]].
  repeat (split; trivial).
  apply (sconjImplR Hp); clear HGnew Hset_eq Hp; intros h Hp.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  hypReplace Hp (aconjER Hp).
  apply aconjIntro1; assumption.*)
  assert (Hpre : imarkPreP s' empty_set G W free objs ohpSt ohpEnd freePtr
    stBot stBuff stTop numfree (objHp (empty_set |_| G) empty_set **
      objHp ((empty_set |_| G) |_| W) (G |_| W))).
  destruct Hpre' as [Hroot [Hnumfree [_ [Hst [Hed [Hobjs [Hset_eq Hp]]]]]]].
  repeat (split; trivial).
  apply (sconjImplR Hp); clear HGnew Hset_eq Hp; intros h Hp.
  repeat (apply (sconjImplR Hp); clear h Hp; intros h Hp).
  hypReplace Hp (aconjER Hp).
  apply aconjIntro1; assumption.
  hypReplace HGnew (HGnew _ _ _ _ _ _ _ _ _ _ _ _ Hpre); clear Hpre Hpre'.
  split; intro He.
  2: elimtype False; apply (lt_irrefl numfree);
    apply (lt_le_trans _ _ _ LT He).
  destruct HGnew as [free' [freePtr' [HpInv' Hpost]]].
  split.
  intros x HxinB.
  destruct (HpInv x HxinB) as [GL GR].
  rewrite <- GL; rewrite <- GR.
  unfold HpUnchangeNotInF, hget in HpInv'.
  apply HpInv'; clear HpInv HpInv' Hpost.
  destruct H as [_ [_ [_ [_ [_ [_ [Hset_eq Hp]]]]]]].
  split.
  elimSetIn.
  aconjE2 Hp.
  clear Hp; rename Hh into Hp.
  sconjLift5of5 Hp.
  hypReplace Hp (sconjAssocL (fasElimL HxinB Hp)).
  sconjLift6of6 Hp.
  unfold okObjAt, okFieldAt in Hp.
  linLogElim Hp.
  apply (ifreeList_cont_notIn _ _ _ _ _ _ Hp).
  exists G; exists W; exists stTop; exists freePtr'; exists free'.
  assumption.
  
  destruct HGgc as [_ [Hcall Hcst0]].
  assert (Hr : (forall r, r <> v0 -> r <> ra -> r <> rtemp -> r <> rnumfree ->
    rget s'' r = rget s' r) /\ rget s' rcst0 = rget s'' ra).
  destruct HGnew as [[_ [_ HG]] | [[_ [_ HG]] | [_ [_ HG]]]]; assumption.
  destruct Hr as [Hr Hra'']; clear HGnew.
  apply raAndOthers.
  apply calleeSavedOkTrans' with s'.
  generalize Hcall; clear Hcall.
  unfold calleeSavedOk, regPres, calleeSaved, regInList.
  intros Hrr.
  intros r HcalleeSav'.
  destruct HcalleeSav' as [H | [H | [H | [H | [
    H | [H | [H | [H | H]]]]]]]];
  try (subst r; rewrite <- Hrr; intuition).
  elim H.
  clear Hcall.
  intros r HcalleeSav'.
  destruct HcalleeSav' as [H | [H | [H | [H | [
    H | [H | [H | [H | H]]]]]]]];
  try (subst r;regEqSolver).
  elim H.
  rewrite <- Hra''; assumption.
Qed.
