Require Import Heap.
Require Import WeakSCAP.
Require Import LinLog.
Require Import Machine.
Require Import List.
Require Import SpecUtil.
Require Import GC.
Require Import NatUtil.
Require Import StateTheory.
Require Import Arith.
Require Import MarkSweepGC.
Require Import MarkSweepLemma.
Require Import BuffArrayStack.
Require Import IMarkSweepGC.

Theorem isweepImplOk :
  iseqOkS isweepP isweepPre isweepGuar isweepImpl.
Proof.
  unfold isweepImpl.
  iseqWeakSolver PsimplISweep.
  
  unfold isweepPre; unfold isweepGuar; unfold isweepLoopPre;
    unfold isweepLoopGuar; unfold isweepPreP; unfold isweepLoopPreP.
  intros s [B [W [objs [free [swept [ohpSt [ohpEnd [freePtr [stBot [stBuff
    [sweepAt [numfree [Hroot [Hphase [Hnumfree [Hst [Hed [HdifW [Hobjs
      [Hswept [Hat [Hset_eq Hp]]]]]]]]]]]]]]]]]]]]]].
  assert (Hp' := Hp).
  sconjLift4 Hp.
  unfold contL in Hp.
  smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (HgetEnd := contGetEqL Hp).
  sconjLift2 Hp; smartAssocL Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (HgetFP := contGetEqL Hp).
  sconjLift2 Hp; smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (HgetSAt := contGetEqL Hp).
  sconjLift2 Hp; smartAssocL Hp.
  rewrite (lwStep Hp); stSimpl; trivial.
  assert (HgetNF := contGetEqL Hp).
  rewrite addiuStep; trivial.
  stSimpl.
  
  split.
  exists B; exists W; exists objs; exists free; exists swept; 
    exists ohpSt; exists freePtr; exists stBot; exists stBuff; 
      exists sweepAt; exists numfree.
  repeat(split; trivial).
  omega.

  clear Hp' Hp Hset_eq Hat Hswept Hobjs HdifW Hed Hst Hnumfree Hphase 
    Hroot stBuff stBot  ohpSt swept free objs W B.
  
  intros s' [HG [Hcall [Hcst1 Hcst0]]].
  split.
  intros.
  destruct H as [Hroot [Hphase [Hnumfree [Hst [Hed [HdifW [Hobjs [Hswept
    [Hat [Hset_eq Hp]]]]]]]]]].
  assert (Hp' := Hp).
  sconjLift4 Hp.
  unfold contL in Hp.
  smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  assert (HgetEnd' := contGetEqL Hp).
  rewrite HgetEnd in HgetEnd'; inversion HgetEnd'.
  subst ohpEnd0; clear HgetEnd' HgetEnd.
  sconjLift2 Hp; smartAssocL Hp.
  assert (HgetFP' := contGetEqL Hp).
  rewrite HgetFP in HgetFP'; inversion HgetFP'.
  subst freePtr0; clear HgetFP' HgetFP.
  sconjLift2 Hp; smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  sconjLift2 Hp; smartAssocL Hp.
  assert (HgetSAt' := contGetEqL Hp).
  rewrite HgetSAt in HgetSAt'; inversion HgetSAt'.
  subst sweepAt0; clear HgetSAt' HgetSAt.
  sconjLift2 Hp; smartAssocL Hp.
  assert (HgetNF' := contGetEqL Hp).
  rewrite HgetNF in HgetNF'; inversion HgetNF'.
  subst numfree0; clear HgetNF' HgetNF Hp.
  exists (rget s' rsweepsum).
  assert (exists W', exists free', exists swept', exists freePtr',
    exists sweepAt', exists numfree',
      isweepPost s' B W' objs free' swept' ohpSt ohpEnd
      freePtr' stBot stBuff sweepAt' numfree' A /\
      rget s' rbot + 12 * (0 + 0) = sweepAt + 12 * rget s' rsweepsum).
  apply HG with W free swept freePtr sweepAt numfree; clear HG.
  repeat (split; trivial).
  omega.
  rewrite H0; trivial.
  clear HG.
  destruct H as [W0 [free0 [swept0 [freePtr0
    [sweepAt0 [numfree0 [Hpost Hswps]]]]]]].
  exists W0; exists free0; exists swept0; exists freePtr0;
    exists sweepAt0; exists numfree0.
  split; trivial.
  split.
  rewrite <- Hswps; auto.
  destruct Hpost as [_ [Hsws' _]]; trivial.
  clear HG.
  split.
  eapply calleeSavedOkTrans.
  2: apply Hcall.
  calleeSavedOkSolver.
  split; trivial.
Qed.

Theorem isweepLoopImplOk :
  iseqOkS isweepP isweepLoopPre isweepLoopGuar isweepLoopImpl.
Proof.
  unfold isweepLoopImpl.
  iseqWeakSolverlg PsimplISweep.
  
  intros s [B [W [objs [free [swept [ohpSt [freePtr [stBot [stBuff [sweepAt 
    [numfree [Hroot [Hphase [Hswsum [Hnumfree [Hst [Hed [HdifW [Hobjs [Hswept 
      [Hat [Hset_eq Hp]]]]]]]]]]]]]]]]]]]]]].
  rewrite addiuStep; stSimpl; trivial.
  rewrite sltuStep; stSimpl.
  doBtestSimpl.
  
  (* rhpEnd < 12 +  rsweep sweep finish *)
  unfold isweepFinishedPre; unfold isweepFinishedGuar;
    unfold isweepFinishedPreP.
  unfold isweepLoopGuar; unfold isweepLoopPreP.
  stSimpl.

  split.
  exists B; exists objs; exists free; exists swept;
    exists ohpSt; exists freePtr; exists stBot;
      exists stBuff; exists sweepAt; exists numfree.
  assert (HdisjBF: set_disj B free).
  eapply  (objHp_ifreelist_disj B B free (rget s rfree) (heapOf s) objs ohpSt (rget s rhpEnd)).
  apply Hobjs.
  assert (Hs := set_subsetRefl B).
  hypReplace Hs (set_subsetUnionIntroL Hs W).
  hypReplace Hs (set_subsetUnionIntroL Hs free).
  setoid_rewrite <- Hset_eq; trivial.
  assert (Hp' := sconjAssocL (sconjComm (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR Hp)))))).
  apply (sconjImplR Hp'); clear Hp'; intros h Hp'.
  apply (sconjImplL Hp'); clear h Hp' Hp; intros h Hp.
  apply aconjER with top; trivial.
  assert (Hsub: set_subset objs swept).
  subst objs; subst swept.
  apply rangeMSObjsSubSet.
  omega.
  assert (set_diff W swept = empty_set).
  apply set_diffSuperSet.
  apply set_subsetTrans with objs; trivial.
  assert (Hs := set_subsetRefl W).
  hypReplace Hs (set_subsetUnionIntroL Hs B).
  hypReplace Hs (set_subsetUnionIntroL Hs free).
  setoid_rewrite <- Hset_eq.
  setoid_rewrite (set_eqvUnionSymm B W); assumption.
  assert (W = empty_set).
  rewrite HdifW in H; inversion_clear H.
  reflexivity.
  subst W; clear H.
  rewrite <- set_unionEmpty in Hset_eq.

  repeat (split; trivial).
  hypReplace Hp (sconjAssocR Hp).
  apply (sconjImpl Hp).
  clear Hp; intros h Hp.
  rewrite objHdrsCEq; setoid_rewrite <- Hset_eq; rewrite <- objHdrsCEq.
  apply objHdrsMerge.
  apply (sconjImpl Hp).
  clear h Hp; intros h Hp.
  eapply bobjHdrsElim.
  2: apply Hp.
  clear h Hp; intros x HinB.
  assert (HinSwept : set_In x swept).
  apply Hsub.
  setoid_rewrite <- Hset_eq.
  apply set_union_intro1; trivial.
  rewrite Hswept in HinSwept.
  destruct (rangeMSObjsElim _ _ _ HinSwept) as [Hlt _].
  omega.
  rewrite <- set_unionEmptyL; trivial.
  clear Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  assert (h ||- unit ** ifreeList (rget s rfree) free ** top && objHp B B).
  apply (sconjImpl Hp); trivial.
  apply unitEL; trivial.

  clear Hp Hset_eq Hat Hswept Hobjs HdifW Hed Hst Hnumfree Hswsum Hphase 
    Hroot numfree sweepAt stBuff stBot freePtr ohpSt swept free objs W B.
  intros s' [HG [Hcall [Hcst1 Hcst0]]].

  split.
  intros.
  destruct H as [Hroot [Hphase [Hswsum [Hnumfree [Hst [Hed [HdifW 
    [Hobjs [Hswept [Hat [Hset_eq Hp]]]]]]]]]]].
  exists empty_set.
  assert (exists free', exists swept', exists freePtr', exists sweepAt',
    exists numfree',
      isweepPost s' B empty_set objs free' swept' ohpSt (rget s rbuff) freePtr'
      stBot stBuff sweepAt' numfree' A /\ sweepAt' = ohpSt /\
      rget s' rbot = rget s rbot /\
      rget s' rnumfree = rget s rnumfree /\
      rget s' rsweepsum = rget s rsweepsum).
  apply HG with free swept freePtr sweepAt numfree; clear HG.
  assert (HdisjBF: set_disj B free).
  eapply  (objHp_ifreelist_disj B B free (rget s rfree) (heapOf s) objs ohpSt (rget s rhpEnd)).
  apply Hobjs.
  assert (Hs := set_subsetRefl B).
  hypReplace Hs (set_subsetUnionIntroL Hs W).
  hypReplace Hs (set_subsetUnionIntroL Hs free).
  setoid_rewrite <- Hset_eq; assumption.
  assert (Hp' := sconjAssocL (sconjComm (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR Hp)))))).
  apply (sconjImplR Hp'); clear Hp'; intros h Hp'.
  apply (sconjImplL Hp'); clear h Hp' Hp; intros h Hp.
  apply aconjER with A; trivial.
  assert (Hsub: set_subset objs swept).
  subst objs; subst swept.
  apply rangeMSObjsSubSet.
  omega.
  assert (set_diff W swept = empty_set).
  apply set_diffSuperSet.
  apply set_subsetTrans with objs; trivial.
  assert (Hs := set_subsetRefl W).
  hypReplace Hs (set_subsetUnionIntroL Hs B).
  hypReplace Hs (set_subsetUnionIntroL Hs free).
  setoid_rewrite <- Hset_eq.
  setoid_rewrite (set_eqvUnionSymm B W); assumption.
  assert (W = empty_set).
  rewrite HdifW in H; inversion_clear H.
  reflexivity.
  subst W; clear H.
  rewrite <- set_unionEmpty in Hset_eq.

  repeat (split; trivial).
  hypReplace Hp (sconjAssocR Hp).
  apply (sconjImpl Hp); clear Hp; intros h Hp.
  rewrite objHdrsCEq; setoid_rewrite <- Hset_eq; rewrite <- objHdrsCEq.
  apply objHdrsMerge.
  apply (sconjImpl Hp).
  clear h Hp; intros h Hp.
  eapply bobjHdrsElim.
  2: apply Hp.
  clear h Hp; intros x HinB.
  assert (HinSwept : set_In x swept).
  apply Hsub.
  setoid_rewrite <- Hset_eq.
  apply set_union_intro1; trivial.
  rewrite Hswept in HinSwept.
  destruct (rangeMSObjsElim _ _ _ HinSwept) as [Hlt _].
  omega.
  rewrite <- set_unionEmptyL; trivial.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  assert (h ||- unit ** ifreeList (rget s rfree) free ** A && objHp B B).
  apply (sconjImpl Hp); trivial.
  apply unitEL; trivial.

  destruct H as [free0 [swept0 [freePtr0 [sweepAt0 [numfree0 
    [Hpost [HeAt' [HeAt [Hnumf HeNums]]]]]]]]].
  exists free0; exists swept0; exists freePtr0; exists sweepAt0; exists numfree0.
  split; trivial.
  rewrite HeNums; rewrite HeAt; trivial.
  split.
  eapply calleeSavedOkTrans.
  2 : apply Hcall.
  calleeSavedOkSolver.
  split; trivial.
  
  rewrite addiuStep; trivial.
  rewrite subuStep; trivial.
  stSimpl.
  
  unfold doBtest.
  compare (5 + 0 - rget s rsweepsum) 0; intros HeNumswp.
  
  (* rsweepsum = NUMSWEEP donesomesweep *)
  rewrite HeNumswp.
  rewrite beq_true.
  
  unfold isweepDoneSomeGuar; unfold isweepDoneSomePre;
    unfold isweepDoneSomePreP.
  stSimpl.

  split.
  exists B; exists W; exists objs; exists free;
    exists swept; exists ohpSt; exists freePtr; 
      exists stBot; exists stBuff; exists sweepAt; exists numfree.
  repeat (split; trivial).
  omega.
  clear Hp Hset_eq Hat Hswept Hobjs HdifW Hed Hst Hnumfree Hswsum Hphase 
    Hroot numfree sweepAt stBuff stBot freePtr ohpSt swept free objs W B.
  intros s' [HG [Hcall [Hcst1 Hcst0]]].

  split.
  intros.
  destruct H as [Hroot [Hphase [Hswsum [Hnumfree [Hst [Hed
    [HdifW [Hobjs [Hswept [Hat [Hset_eq Hp]]]]]]]]]]].
  assert (exists W', exists free', exists swept', exists freePtr',
    exists sweepAt', exists numfree',
      isweepPost s' B W' objs free' swept' ohpSt (rget s rbuff) freePtr'
      stBot stBuff sweepAt' numfree' A /\
      rget s' rbot = rget s rbot /\
      rget s' rnumfree = rget s rnumfree /\
      rget s' rsweepsum = rget s rsweepsum).
  apply HG with W free swept freePtr sweepAt numfree; clear HG.
  repeat (split; trivial).
  omega.
  destruct H as [W0 [free0 [swept0 [freePtr0 [sweepAt0 [numfree0
    [Hpost [HeAt [HeNumf HeNums]]]]]]]]].
  exists W0; exists free0; exists swept0; exists freePtr0;
    exists sweepAt0; exists numfree0.
  split; trivial.
  rewrite HeNums; rewrite HeAt; trivial.
  split.
  eapply calleeSavedOkTrans.
  2 : apply Hcall.
  calleeSavedOkSolver.
  split; trivial.
  (* rsweepsum < FREE_THREDHOLD sweep*)
  rewrite beq_false.
  2 : trivial.
  destruct Hat as [k Hk].
  assert (set_In (4 + rget s rsweep) objs).
  rewrite Hobjs.
  apply rangeMSObjsIntro with k; trivial.
  omega.
  rewrite Hk; omega.
  assert (NI : ~ set_In (4 + rget s rsweep) swept).
  rewrite Hswept.
  intro I.
  destruct (rangeMSObjsElim _ _ _ I).
  omega.
 
  assert (In : s |||- (rget s rsweep) |-> 0 ** top \/
    heapOf s ||- (rget s rsweep) |-> 1 ** top).
  assert (Ho := set_eqvTrans (set_eqvSymm (set_eqvUnionAssoc B W free)) Hset_eq).
  destruct (Ho (4 + rget s rsweep)) as [_ Hx].
  destruct (set_union_elim (Hx H)) as [In | In]; 
    clear H Hx.
  right.
  unfold objHdrs in Hp; unfold bobjHdrs in Hp.
  assert (Hp' := sconjAssocL (fasElimL In Hp)).
  simpl in Hp'.
  rewrite blt_false in Hp'.
  replace (rget s rsweep) with (rget s rsweep - 0); [idtac | auto with arith].
  apply (sconjImplR Hp').
  unfold top; unfold hpredTrue; trivial.
  omega.
  left.
  unfold objHdrs in Hp; unfold bobjHdrs in Hp.
  assert (Hp' := sconjAssocL (fasElimL In (sconjAssocL (sconjComm Hp)))).
  simpl in Hp'.
  replace (rget s rsweep) with (rget s rsweep - 0); [idtac | auto with arith].
  apply (sconjImplR Hp').
  unfold top; unfold hpredTrue; trivial.
  destruct In as [HinUmk | HinMk].
  rewrite (lwStep HinUmk); stSimpl; trivial.
  rewrite beq_true.

  (* UNMARK, in W or free, sweepadd *)
  unfold isweepAddGuar; unfold isweepAddPre;
    unfold isweepAddPreP; unfold isweepLoopGuar;
      unfold isweepLoopPreP.
  stSimpl.

  split.
  exists B; exists W; exists objs; exists free; exists swept; 
    exists ohpSt; exists freePtr; exists stBot; exists stBuff; 
      exists sweepAt; exists numfree.
  repeat (split; trivial).
  omega.
  exists k; trivial.
  assert (Ho := set_eqvTrans (set_eqvSymm (set_eqvUnionAssoc B W free)) Hset_eq).
  destruct (Ho (4 + rget s rsweep)) as [_ Hx].
  destruct (set_union_elim (Hx H)) as [HinB | HinWF].
  unfold objHdrs in Hp; unfold bobjHdrs in Hp.
  assert (Hp' := sconjAssocL (fasElimL HinB Hp)).
  simpl in Hp'.
  rewrite blt_false in Hp'.
  assert (Hgetat' : Heap.get (heapOf s) (rget s rsweep - 0) = Some 1).
  eapply contGetEqL.
  apply Hp'.
  assert (Hgetat : Heap.get (heapOf s) (rget s rsweep - 0) = Some 0).
  eapply contGetEqL.
  replace (rget s rsweep - 0) with (rget s rsweep); [idtac | auto with arith].
  apply HinUmk.
  rewrite Hgetat' in Hgetat; inversion Hgetat.
  omega.
  assumption.
  clear Hp Hset_eq Hswept Hobjs HdifW Hk k H NI Hed Hst Hnumfree Hswsum Hphase
    Hroot numfree sweepAt stBuff stBot freePtr ohpSt swept free objs W B.
  intros s' [HG [Hcall [Hcst1 Hcst0]]].

  split.
  intros.
  destruct H as [Hroot [Hphase [Hswsum [Hnumfree [Hst [Hed [HdifW [Hobjs
    [Hswept [Hat [Hset_eq Hp]]]]]]]]]]].
  apply HG with W free swept freePtr sweepAt numfree; clear HG.
  repeat (split; trivial).
  omega.
  destruct Hat as [k Hk].
  assert (set_In (4 + rget s rsweep) objs).
  rewrite Hobjs.
  apply rangeMSObjsIntro with k; trivial.
  omega.
  rewrite Hk; omega.
  assert (Ho := set_eqvTrans (set_eqvSymm (set_eqvUnionAssoc B W free)) Hset_eq).
  destruct (Ho (4 + rget s rsweep)) as [_ Hx].
  destruct (set_union_elim (Hx H)) as [HinB | HinWF].
  unfold objHdrs in Hp; unfold bobjHdrs in Hp.
  assert (Hp' := sconjAssocL (fasElimL HinB Hp)).
  simpl in Hp'.
  rewrite blt_false in Hp'.
  assert (Hgetat' : Heap.get (heapOf s) (rget s rsweep - 0) = Some 1).
  eapply contGetEqL.
  apply Hp'.
  assert (Hgetat : Heap.get (heapOf s) (rget s rsweep - 0) = Some 0).
  eapply contGetEqL.
  replace (rget s rsweep - 0) with (rget s rsweep); [idtac | auto with arith].
  apply HinUmk.
  rewrite Hgetat' in Hgetat; inversion Hgetat.
  omega.
  trivial.
  split.
  eapply calleeSavedOkTrans.
  2 : apply Hcall.
  calleeSavedOkSolver.
  split; trivial.
  (* in B, unmark it *)
  rewrite (lwStep HinMk); stSimpl; trivial.
  rewrite beq_false.
  2 : auto.
  assert (Ho := set_eqvTrans (set_eqvSymm (set_eqvUnionAssoc B W free)) Hset_eq).
  destruct (Ho (4 + rget s rsweep)) as [_ Hx].
  destruct (set_union_elim (Hx H)) as [HinB | HinWF].
  unfold objHdrs in Hp; unfold bobjHdrs in Hp.
  assert (Hp' := sconjAssocL (fasElimL HinB Hp)).
  simpl in Hp'.
  rewrite blt_false in Hp'; [idtac | omega].
  rewrite (swStep Hp'); stSimpl; auto with arith; clear Hp'.

  unfold isweepNextGuar; unfold isweepNextPre;
    unfold isweepNextPreP; unfold isweepLoopGuar;
      unfold isweepLoopPreP.
  stSimpl.
  split.
  exists B; exists W; exists objs; exists free;
    exists (rangeMSObjs ohpSt (23 + rget s rsweep)); exists ohpSt;
      exists freePtr; exists stBot; exists stBuff; exists sweepAt; exists numfree.
  repeat (split; trivial).
  omega.
  apply set_disj_intro.
  intros.
  eapply set_disj_elim.
  unfold set_disj; apply HdifW.
  apply H0.
  replace (23 + rget s rsweep) with
    (12 + (11 + rget s rsweep)) in H1.
  assert (4 + rget s rsweep = ohpSt + 4 + 12 * k).
  omega.

  rewrite <- (rangeMSObjsRemoveMax _ (11 + rget s rsweep) 
    (4 + rget s rsweep) k H2) in H1.
  destruct H1.
  subst x; elimtype False.
  assert (HinWF := set_union_intro1 _ _ free H0).
  assert (Hp' := sconjAssocL (fasElimL HinWF  (sconjAssocL (sconjComm Hp)))).
  simpl in Hp'.
  assert (Hgetat' : Heap.get (heapOf s) (rget s rsweep - 0) = Some 0).
  eapply contGetEqL.
  apply Hp'.
  clear Hp'.
  assert (Hp' := sconjAssocL (fasElimL HinB Hp)).
  simpl in Hp'.
  rewrite blt_false in Hp'.
  assert (Hgetat : Heap.get (heapOf s) (rget s rsweep - 0) = Some 1).
  eapply contGetEqL.
  apply Hp'.
  rewrite Hgetat' in Hgetat; inversion Hgetat.
  omega.
  rewrite Hswept; apply H1.
  omega.
  omega.
  omega.
  exists k; trivial.
  apply uhsetHOS.
  stSimpl.
  assert (Hp' := sconjAssocL (fasElimL HinB Hp)).
  simpl in Hp'.
  rewrite blt_false in Hp'.
  assert (Htmp := contUpdateSt Hp' 0).
  apply (sconjImpl (sconjAssocR Htmp)).
  clear Hp' Htmp Hp; intros h Hp.
  unfold bobjHdrs.
  apply fasEqvSet with ((4 + rget s rsweep) :: 
    (set_remove (4 + rget s rsweep) B)).
  apply fasIntro.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  rewrite blt_true; trivial.
  omega.
  rewrite Hk.
  replace (12 + 4 + (ohpSt + 12 * k)) with 
  (12 + (ohpSt + 4) + 12 * k).
  rewrite <- bobjHdrsCEq.
  apply bobjHdrsStep; trivial.
  intro X.
  destruct (set_remove_elim _ _ _ X).
  apply H0.
  replace (ohpSt + 4) with (4 + ohpSt); [idtac | auto with arith].
  auto with arith.
  intros.
  destruct (set_remove_elim _ _ _ H0) as [_ X].
  assert (I : set_In x objs).
  elimSetIn.
  rewrite Hobjs in I.
  destruct (rangeMSObjsElim _ _ _ I).
  apply H2.
  unfold bobjHdrs.
  rewrite <- Hk.
  replace (ohpSt + 4 + 12 * k) with (4 + rget s rsweep).
  apply Hp.
  omega.
  omega.
  intro X.
  destruct (set_remove_elim _ _ _ X).
  apply H0; reflexivity.
  split; intros.
  destruct H0.
  subst a; elimSetIn.
  eapply set_remove_elim1; apply H0.
  elimSetIn.
  trivial.
  omega.
  clear Hp HinB Hx Hset_eq Hswept Hobjs HdifW Hk k H NI Hed Hst Hnumfree Ho 
    Hroot Hswsum Hphase numfree sweepAt stBuff stBot freePtr ohpSt swept free objs W B.
  intros s' [HG [Hcall [Hcst1 Hcst0]]].
  split.
  intros.
  destruct H as [Hroot [Hphase [Hswsum [Hnumfree [Hst [Hed
    [HdifW [Hobjs [Hswept [Hat [Hset_eq Hp]]]]]]]]]]].
  apply HG with W free (rangeMSObjs ohpSt (23 + rget s rsweep))
    freePtr sweepAt numfree; clear HG.
  destruct Hat as [k Hk].
  assert (set_In (4 + rget s rsweep) objs).
  rewrite Hobjs.
  apply rangeMSObjsIntro with k; trivial.
  omega.
  rewrite Hk; omega.
  assert (NI : ~ set_In (4 + rget s rsweep) swept).
  rewrite Hswept.
  intro I.
  destruct (rangeMSObjsElim _ _ _ I).
  omega.
  assert (Ho := set_eqvTrans (set_eqvSymm (set_eqvUnionAssoc B W free)) Hset_eq).
  destruct (Ho (4 + rget s rsweep)) as [_ Hx].
  destruct (set_union_elim (Hx H)) as [HinB | HinWF].
  unfold objHdrs in Hp; unfold bobjHdrs in Hp.
  repeat (split; trivial).
  omega.
  apply set_disj_intro.
  intros.
  eapply set_disj_elim.
  unfold set_disj; apply HdifW.
  apply H0.
  replace (23 + rget s rsweep) with
    (12 + (11 + rget s rsweep)) in H1.
  assert (4 + rget s rsweep = ohpSt + 4 + 12 * k).
  omega.

  rewrite <- (rangeMSObjsRemoveMax _ (11 + rget s rsweep) 
    (4 + rget s rsweep) k H2) in H1.
  destruct H1.
  subst x; elimtype False.
  assert (HinWF := set_union_intro1 _ _ free H0).
  assert (Hp' := sconjAssocL (fasElimL HinWF  (sconjAssocL (sconjComm Hp)))).
  simpl in Hp'.
  assert (Hgetat' : Heap.get (heapOf s) (rget s rsweep - 0) = Some 0).
  eapply contGetEqL.
  apply Hp'.
  clear Hp'.
  assert (Hp' := sconjAssocL (fasElimL HinB Hp)).
  simpl in Hp'.
  rewrite blt_false in Hp'.
  assert (Hgetat : Heap.get (heapOf s) (rget s rsweep - 0) = Some 1).
  eapply contGetEqL.
  apply Hp'.
  rewrite Hgetat' in Hgetat; inversion Hgetat.
  omega.
  rewrite Hswept; apply H1.
  omega.
  omega.
  omega.
  exists k; trivial.
  apply uhsetHOS.
  stSimpl.
  assert (Hp' := sconjAssocL (fasElimL HinB Hp)).
  simpl in Hp'.
  rewrite blt_false in Hp'.
  assert (Htmp := contUpdateSt Hp' 0).
  eapply sconjImpl.
  apply (sconjAssocR Htmp).
  clear Hp' Htmp Hp; intros h Hp.
  unfold bobjHdrs.
  apply fasEqvSet with ((4 + rget s rsweep) :: 
    (set_remove (4 + rget s rsweep) B)).
  apply fasIntro.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  rewrite blt_true; trivial.
  omega.
  rewrite Hk.
  replace (12 + 4 + (ohpSt + 12 * k)) with 
  (12 + (ohpSt + 4) + 12 * k).
  rewrite <- bobjHdrsCEq.
  apply bobjHdrsStep; trivial.
  intro X.
  destruct (set_remove_elim _ _ _ X).
  apply H0.
  replace (ohpSt + 4) with (4 + ohpSt); [idtac | auto with arith].
  auto with arith.
  intros.
  destruct (set_remove_elim _ _ _ H0) as [_ X].
  assert (I : set_In x objs).
  elimSetIn.
  rewrite Hobjs in I.
  destruct (rangeMSObjsElim _ _ _ I).
  apply H2.
  unfold bobjHdrs.
  rewrite <- Hk.
  replace (ohpSt + 4 + 12 * k) with (4 + rget s rsweep).
  apply Hp.
  omega.
  omega.
  intro X.
  destruct (set_remove_elim _ _ _ X).
  apply H0; reflexivity.
  split; intros.
  destruct H0.
  subst a; elimSetIn.
  eapply set_remove_elim1; apply H0.
  elimSetIn.
  trivial.
  omega.
  assert (Hp' := sconjAssocL (fasElimL HinWF  (sconjAssocL (sconjComm Hp)))).
  simpl in Hp'.
  assert (Hgetat' : Heap.get (heapOf s) (rget s rsweep - 0) = Some 0).
  eapply contGetEqL.
  apply Hp'.
  clear Hp'.
  assert (Hgetat : Heap.get (heapOf s) (rget s rsweep) = Some 1).
  eapply contGetEqL.
  apply HinMk.
  replace (rget s rsweep - 0) with (rget s rsweep) in Hgetat'; [idtac | auto with arith].
  rewrite Hgetat' in Hgetat; inversion Hgetat.
  split; trivial.
  eapply calleeSavedOkTrans.
  2 : apply Hcall.
  calleeSavedOkSolver.
  split; trivial.
  unfold objHdrs in Hp.
  assert (Hp' := sconjAssocL (fasElimL HinWF  (sconjAssocL (sconjComm Hp)))).
  simpl in Hp'.
  assert (Hgetat' : Heap.get (heapOf s) (rget s rsweep - 0) = Some 0).
  eapply contGetEqL.
  apply Hp'.
  clear Hp'.
  assert (Hgetat : Heap.get (heapOf s) (rget s rsweep) = Some 1).
  eapply contGetEqL.
  apply HinMk.
  replace (rget s rsweep - 0) with (rget s rsweep) in Hgetat'; [idtac | auto with arith].
  rewrite Hgetat' in Hgetat; inversion Hgetat.
Qed.

Theorem isweepAddImplOk :
  iseqOkS isweepP isweepAddPre isweepAddGuar isweepAddImpl.
Proof.
  unfold isweepAddImpl.
  iseqWeakSolver PsimplISweep.

  intros s [B [W [objs [free [swept [ohpSt [freePtr [stBot [stBuff [sweepAt 
    [numfree [Hroot [Hphase [Hswsum [Hnumfree [Hlt [Hst [Hed  [HdifW [Hobjs 
      [Hswept [Hat [Hset_eq [Hin Hp]]]]]]]]]]]]]]]]]]]]]]]].
  set (GCINFO := rget s rgcInfo |->, (ohpSt :: rget s rbuff :: freePtr :: stBot
    :: stBuff :: stBot :: sweepAt :: numfree :: nil)) in * .
  destruct (set_union_elim Hin) as [HinW | Hinfree].
  sconjLift5 Hp.
  hypReplace Hp (sconjAssocL (fasElimL HinW Hp)).
  unfold okObjAt, okFieldAt in Hp.
  linLogElim Hp.
  assert (Hgetx0 := contGetEqL (sconjAssocL (sconjComm Hp))).
  rewrite (lwStep (sconjAssocL (sconjComm Hp))); stSimpl; trivial.
  rewrite addiuStep; stSimpl; trivial.
  unfold doBtest; rewrite beq_false.
  rewrite (swStep Hp); stSimpl; trivial.
  hypReplace Hp (contUpdateSt Hp (rget s rfree)).
  sconjLift2 Hp.
  rewrite (swStep Hp); stSimpl; trivial.
  rewrite addiuStep; trivial.
  rewrite addiuStep; trivial.
  unfold isweepNextPre; unfold isweepNextGuar; unfold isweepNextPreP.
  unfold isweepAddGuar; unfold isweepAddPreP. 
  stSimpl.

  split.
  exists B; exists (set_remove (4 + rget s rsweep) W); exists objs;
    exists ((4 + rget s rsweep) :: free);
      exists (rangeMSObjs ohpSt (23 + rget s rsweep));
	exists ohpSt; exists freePtr; exists stBot; exists stBuff;
	  exists sweepAt; exists numfree.
  
  assert (HnotinF : ~set_In (4 + rget s rsweep) free).
  assert (HgetSx0 := contGetEqL Hp).
  intro.
  sconjLift8 Hp.
  assert ((Heap.uset (heapOf s) (4 + rget s rsweep) (rget s rfree)) ||- 
    ifreeList (rget s rfree) free ** top).
  apply (sconjImplR Hp).
  intros; linLogIntro.
  assert (Htmp := inFreeListVal free (rget s rfree) (4 + rget s rsweep) _ _ H0 H).
  linLogElim Htmp.
  assert (HgetSx0' := contGetEqL (sconjAssocL (sconjComm Htmp))).
  rewrite HgetSx0 in HgetSx0'.
  inversion HgetSx0'.
  subst x0.
  destruct H6 as [Hatom | Hinset].
  inversion Hatom.
  inversion_clear H2.
  inversion_clear H4.
  assert (Ho := inFreeListnotinMSobjs _ _ _ Hobjs).
  apply Ho; trivial.

  replace (23 + rget s rsweep) with
    (12 + (11 + rget s rsweep)); [idtac | omega].
  destruct Hat as [k Hk].
  assert (4 + rget s rsweep = ohpSt + 4 + 12 * k).
  omega.
  rewrite <- (rangeMSObjsRemoveMax _ (11 + rget s rsweep) 
    (4 + rget s rsweep) k H); [idtac | omega | omega].
  clear H.

  repeat (split; trivial).
  rewrite Hnumfree; apply notInPlus'; trivial.
  apply set_disj_intro.
  intros.
  destruct H0.
  subst x1.
  apply (set_remove_elim2 _ H); reflexivity.
  rewrite Hswept in HdifW.
  apply (set_disj_elim HdifW x1); trivial.
  elimSetIn.
  exists k; trivial.
  intro X.
  elimSetIn.
  intro X.
  compare a (4 + rget s rsweep); intro e.
  elimSetIn.
  assert (set_In a (set_union (set_union B W) free)).
  setoid_rewrite Hset_eq; trivial.
  elimSetIn.
  hypReplace Hp (contUpdateSt Hp INFREELIST).
  apply sconjAssocL.
  apply sconjGLift2'.
  sconjLift6 Hp.
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  subst GCINFO.
  apply sconjGLift2'.
  sconjLift6 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply sconjGLift2'.
  sconjLift3 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply sconjGLift2'.
  sconjLift5 Hp.
  apply (sconjImpl (sconjAssocR (sconjAssocR Hp)));
    clear h Hp; intros h Hp.
  simpl.
  exists (rget s rfree).
  apply sconjAssocL.
  linLogIntro.
  unfold NULL; auto with arith.
  smartAssocL Hp.
  sconjLift2 Hp.
  sconjLift3of3 Hp.
  apply Hp.
  apply (sconjImplL (sconjAssocR Hp)); clear h Hp; intros h Hp.
  assert (~ set_In (4 + rget s rsweep) B).
  intro X.
  assert (Heap.get h (rget s rsweep - 0) = Some 1).
  hypReplace Hp (fasElimL X Hp).
  simpl in Hp.
  rewrite blt_false in Hp.
  eapply contGetEqL; apply (sconjAssocL Hp).
  omega.
  sconjLift2of2 Hp.
  assert (H0 := In_objHdrs_Val _ _ _ _ _ Hp Hin).
  simpl in H0.
  rewrite H in H0; inversion_clear H0.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  rewrite Hk.
  replace (12 + 4 + (ohpSt + 12 * k)) with
    (12 + (4 + ohpSt) + 12 * k); [idtac | omega].
  apply bobjHdrsStep; trivial.
  rewrite Hk in H; trivial.
  intros.
  assert (I : set_In x1 objs).
  elimSetIn.
  rewrite Hobjs in I.
  destruct (rangeMSObjsElim _ _ _ I).
  replace (4 + ohpSt) with (ohpSt + 4); [idtac | auto with arith].
  apply H2.
  rewrite Hk in Hp; trivial.
  unfold objHdrs in Hp; unfold objHdrs.
  eapply fasEqvSet.
  apply Hp. 
  split; intros; elimSetIn.
  assert (Hx0ne : x0 <> INFREELIST).
  eapply OkfieldValnotInfree.
  apply H6.
  eapply inFreeListnotinMSobjs.
  apply Hobjs.

  clear Hp H6 H3 x HinW Hin Hset_eq Hat Hswept Hobjs HdifW Hed Hst Hlt Hnumfree GCINFO
    Hroot Hswsum Hphase numfree sweepAt stBuff stBot freePtr ohpSt swept free objs W B.
  intros s' [HG [Hcall [Hcst1 Hcst0]]].
  
  split.
  intros.
  destruct H as [Hroot [Hphase [Hswsum [Hnumfree [Hlt [Hst [Hed
    [HdifW [Hobjs [Hswept [Hat [Hset_eq [Hin Hp]]]]]]]]]]]]].
  apply HG  with (set_remove (4 + rget s rsweep) W)
     ((4 + rget s rsweep) :: free) 
    (rangeMSObjs ohpSt (23 + rget s rsweep)) freePtr sweepAt numfree; clear HG.
  replace (23 + rget s rsweep) with
    (12 + (11 + rget s rsweep)); [idtac | omega].
  destruct Hat as [k Hk].
  assert (4 + rget s rsweep = ohpSt + 4 + 12 * k).
  omega.
  rewrite <- (rangeMSObjsRemoveMax _ (11 + rget s rsweep) 
    (4 + rget s rsweep) k H); [idtac | omega | omega].
  clear H.

  assert (HnotinF : ~set_In (4 + rget s rsweep) free).
  intro.
  assert (Htmp := sconjAssocL (sconjAssocL (sconjComm (sconjAssocL (sconjComm
    (sconjAssocR (sconjAssocR (sconjAssocR Hp)))))))).
  assert (s |||- ifreeList (rget s rfree) free ** top).
  eapply sconjImplR.
  apply Htmp.
  unfold top; unfold hpredTrue; trivial.
  clear Htmp.
  assert (Htmp := inFreeListVal free (rget s rfree) (4 + rget s rsweep) _ _ H0 H).
  linLogElim Htmp.
  assert (Hgetx0' := contGetEqL (sconjAssocL (sconjComm Htmp))).
  rewrite Hgetx0 in Hgetx0'.
  inversion Hgetx0'.
  apply Hx0ne; trivial.

  assert (HinW := set_InUnion_notinR_inL _ _ _ Hin HnotinF).
  sconjLift5 Hp.
  hypReplace Hp (sconjAssocL (fasElimL HinW Hp)).
  set (GCINFO := rget s rgcInfo |->, (ohpSt :: rget s rbuff :: freePtr :: stBot
    :: stBuff :: stBot :: sweepAt :: numfree :: nil)) in * .
  unfold okObjAt in Hp; unfold okFieldAt in Hp.
  linLogElim Hp.
  sconjLift2 Hp.
  assert (Hgetx0' := contGetEqL Hp).
  rewrite Hgetx0 in Hgetx0'; inversion Hgetx0'.
  subst x1; clear Hgetx0'.

  repeat (split; trivial).
  rewrite Hnumfree; apply notInPlus'; trivial.
  apply set_disj_intro.
  intros.
  destruct H0.
  subst x1.
  apply (set_remove_elim2 _ H); reflexivity.
  rewrite Hswept in HdifW.
  apply (set_disj_elim HdifW x1); trivial.
  elimSetIn.
  exists k; trivial.
  intro X.
  elimSetIn.
  intro X.
  assert (set_In a (set_union (set_union B W) free)).
  setoid_rewrite Hset_eq; trivial.
  elimSetIn.
  sconjLift2 Hp.
  hypReplace Hp (contUpdateSt Hp (rget s rfree)).
  sconjLift2 Hp.
  hypReplace Hp (contUpdateSt Hp INFREELIST).
  unfold uhset; stSimpl.
  apply sconjAssocL.
  apply sconjGLift2'.
  sconjLift6 Hp.
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  subst GCINFO.
  apply sconjGLift2'.
  sconjLift6 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply sconjGLift2'.
  sconjLift3 Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply sconjGLift2'.
  sconjLift5 Hp.
  apply (sconjImpl (sconjAssocR (sconjAssocR Hp)));
    clear h Hp; intros h Hp.
  simpl.
  exists (rget s rfree).
  apply sconjAssocL.
  linLogIntro.
  unfold NULL; auto with arith.
  smartAssocL Hp.
  sconjLift2 Hp.
  sconjLift3of3 Hp.
  apply Hp.
  apply (sconjImplL (sconjAssocR Hp)); clear h Hp; intros h Hp.
  assert (~ set_In (4 + rget s rsweep) B).
  intro X.
  assert (Heap.get h (rget s rsweep - 0) = Some 1).
  hypReplace Hp (fasElimL X Hp).
  simpl in Hp.
  rewrite blt_false in Hp.
  eapply contGetEqL; apply (sconjAssocL Hp).
  omega.
  sconjLift2of2 Hp.
  assert (H0 := In_objHdrs_Val _ _ _ _ _ Hp Hin).
  simpl in H0.
  rewrite H in H0; inversion_clear H0.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  rewrite Hk.
  replace (12 + 4 + (ohpSt + 12 * k)) with
    (12 + (4 + ohpSt) + 12 * k); [idtac | omega].
  apply bobjHdrsStep; trivial.
  rewrite Hk in H; trivial.
  intros.
  assert (I : set_In x1 objs).
  elimSetIn.
  rewrite Hobjs in I.
  destruct (rangeMSObjsElim _ _ _ I).
  replace (4 + ohpSt) with (ohpSt + 4); [idtac | auto with arith].
  apply H2.
  rewrite Hk in Hp; trivial.
  unfold objHdrs in Hp; unfold objHdrs.
  eapply fasEqvSet.
  apply Hp. 
  split; intros; elimSetIn.

  split.
  eapply calleeSavedOkTrans.
  2: apply Hcall.
  calleeSavedOkSolver.
  split; trivial.
  eapply OkfieldValnotInfree.
  apply H6.
  eapply inFreeListnotinMSobjs.
  apply Hobjs.

  assert (Hfreev := inFreeListVal _ _ _ _ _ (sconjAssocL 
    (sconjComm (sconjAssocR (sconjAssocR (sconjAssocR 
      (sconjAssocR Hp)))))) Hinfree).
  linLogElim Hfreev.
  assert (Hgetx0 := contGetEqL (sconjAssocL (sconjComm Hfreev))).
  rewrite (lwStep (sconjAssocL (sconjComm Hfreev))); trivial.
  rewrite addiuStep; trivial.
  unfold doBtest; rewrite beq_true.

  unfold isweepAddGuar; unfold isweepAddPreP;
    unfold isweepNextGuar; unfold isweepNextPre; unfold isweepNextPreP.
  stSimpl.
  
  split.
  exists B; exists W; exists objs; exists free;
    exists (rangeMSObjs ohpSt (23 + rget s rsweep));
      exists ohpSt; exists freePtr; exists stBot; exists stBuff;
	  exists sweepAt; exists numfree.
  repeat (split; trivial).
  replace (23 + rget s rsweep) with
    (12 + (11 + rget s rsweep)); [idtac | omega].
  destruct Hat as [k Hk].
  assert (4 + rget s rsweep = ohpSt + 4 + 12 * k).
  omega.
  rewrite <- (rangeMSObjsRemoveMax _ (11 + rget s rsweep) 
    (4 + rget s rsweep) k H); [idtac | omega | omega].
  clear H.

  apply set_diff_add_r.
  rewrite <- Hswept; trivial.
  intro.
  hypReplace Hp (sconjAssocL (fasElimL H (
    sconjAssocL (sconjComm (sconjAssocR (
      sconjAssocR (sconjAssocR Hp))))))).
  unfold okObjAt in Hp; unfold okFieldAt in Hp.
  linLogElim Hp.
  assert (Hgetx0' := contGetEqL (sconjAssocL (sconjComm Hp))).
  rewrite Hgetx0' in Hgetx0; inversion Hgetx0.
  assert (x1 <> INFREELIST).
  eapply OkfieldValnotInfree.
  apply H7.
  eapply inFreeListnotinMSobjs.
  apply Hobjs.
  apply H0; trivial.
  apply sconjAssocL.
  hypReplace Hp (sconjAssocR Hp).
  apply (sconjImpl Hp); clear Hp.
  intros h Hp.
  assert (~ set_In (4 + rget s rsweep) B).
  intro X.
  assert (Heap.get h (rget s rsweep - 0) = Some 1).
  hypReplace Hp (fasElimL X Hp).
  simpl in Hp.
  rewrite blt_false in Hp.
  eapply contGetEqL; apply (sconjAssocL Hp).
  omega.
  assert (H0 := In_objHdrs_Val _ _ _ _ _ (sconjComm Hp) Hin).
  simpl in H0.
  rewrite H in H0; inversion_clear H0.
  apply (sconjImpl Hp); clear h Hp; intros h Hp; trivial.
  destruct Hat as [k Hk].
  rewrite Hk; rewrite Hk in Hp.
  replace (12 + 4 + (ohpSt + 12 * k)) with
    (12 + (4 + ohpSt) + 12 * k); [idtac | omega].
  apply bobjHdrsStep; trivial.
  replace (4 + ohpSt + 12 * k) with (4 + rget s rsweep);
    [trivial | rewrite Hk; trivial].
  intros.
  assert (I : set_In x0 objs).
  elimSetIn.
  rewrite Hobjs in I.
  destruct (rangeMSObjsElim _ _ _ I).
  replace (4 + ohpSt) with (ohpSt + 4); [idtac | auto with arith].
  apply H2.
  trivial.
  clear Hfreev x Hinfree Hp Hin Hset_eq Hat Hswept Hobjs HdifW  Hed Hst Hlt Hnumfree Hswsum
    GCINFO Hroot Hphase numfree sweepAt stBuff stBot freePtr ohpSt swept free objs W B.
  intros s' [HG [Hcall [Hcst1 Hcst0]]].
  
  split.
  intros.
  destruct H as [Hroot [Hphase [Hswsum [Hnumfree [Hlt [Hst [Hed
    [HdifW [Hobjs [Hswept [Hat [Hset_eq [Hin Hp]]]]]]]]]]]]].
  apply HG  with W free (rangeMSObjs ohpSt (23 + rget s rsweep))
    freePtr sweepAt numfree; clear HG.
  
  repeat (split; trivial).
  replace (23 + rget s rsweep) with
    (12 + (11 + rget s rsweep)); [idtac | omega].
  destruct Hat as [k Hk].
  assert (4 + rget s rsweep = ohpSt + 4 + 12 * k).
  omega.
  rewrite <- (rangeMSObjsRemoveMax _ (11 + rget s rsweep) 
    (4 + rget s rsweep) k H); [idtac | omega | omega].
  clear H.
  apply set_diff_add_r.
  rewrite <- Hswept; trivial.
  intro.
  hypReplace Hp (sconjAssocL (fasElimL H (
    sconjAssocL (sconjComm (sconjAssocR (
      sconjAssocR (sconjAssocR Hp))))))).
  unfold okObjAt in Hp; unfold okFieldAt in Hp.
  linLogElim Hp.
  assert (Hgetx0' := contGetEqL (sconjAssocL (sconjComm Hp))).
  rewrite Hgetx0' in Hgetx0; inversion Hgetx0.
  assert (x0 <> INFREELIST).
  eapply OkfieldValnotInfree.
  apply H7.
  eapply inFreeListnotinMSobjs.
  apply Hobjs.
  apply H0; trivial.
  apply sconjAssocL.
  hypReplace Hp (sconjAssocR Hp).
  apply (sconjImpl Hp).
  clear Hp.
  intros h Hp.
  assert (~ set_In (4 + rget s rsweep) B).
  intro X.
  assert (Heap.get h (rget s rsweep - 0) = Some 1).
  hypReplace Hp (fasElimL X Hp).
  simpl in Hp.
  rewrite blt_false in Hp.
  eapply contGetEqL; apply (sconjAssocL Hp).
  omega.
  assert (H0 := In_objHdrs_Val _ _ _ _ _ (sconjComm Hp) Hin).
  simpl in H0.
  rewrite H in H0; inversion_clear H0.
  apply (sconjImpl Hp); clear h Hp; intros h Hp; trivial.
  destruct Hat as [k Hk].
  rewrite Hk; rewrite Hk in Hp.
  replace (12 + 4 + (ohpSt + 12 * k)) with
    (12 + (4 + ohpSt) + 12 * k); [idtac | omega].
  apply bobjHdrsStep; trivial.
  replace (4 + ohpSt + 12 * k) with (4 + rget s rsweep);
    [trivial | rewrite Hk; trivial].
  intros.
  assert (I : set_In x objs).
  elimSetIn.
  rewrite Hobjs in I.
  destruct (rangeMSObjsElim _ _ _ I).
  replace (4 + ohpSt) with (ohpSt + 4); [idtac | auto with arith].
  apply H2.
  trivial.
  split.
  eapply calleeSavedOkTrans.
  2 : apply Hcall.
  calleeSavedOkSolver.
  split; trivial.
Qed.

Theorem isweepNextImplOk :
  iseqOkS isweepP isweepNextPre isweepNextGuar isweepNextImpl.
Proof.
  unfold isweepNextImpl.
  iseqWeakSolver PsimplISweep.
  
  intros s [B [W [objs [free [swept [ohpSt [freePtr [stBot [stBuff [sweepAt
    [numfree [Hroot [Hphase [Hswsum [Hnumfree [Hst [Hed [HdifW [Hobjs [Hswept
      [Hat[Hset_eq Hp]]]]]]]]]]]]]]]]]]]]]].
  rewrite addiuStep; trivial.
  rewrite addiuStep; trivial.
  unfold isweepLoopGuar; unfold isweepLoopPre; unfold isweepLoopPreP.
  unfold isweepNextGuar; unfold isweepNextPreP.
  stSimpl.
  split.
  exists B; exists W; exists objs; exists free;
    exists swept; exists ohpSt; exists freePtr; exists stBot;
      exists stBuff; exists sweepAt; exists numfree.
  repeat (split; trivial).
  destruct Hat as [k Hat].
  exists (k + 1).
  omega.
  clear Hp Hset_eq Hat Hswept Hobjs HdifW Hed Hst Hnumfree Hphase Hswsum stBuff 
    Hroot stBot numfree sweepAt freePtr ohpSt swept free objs W B.

  intros s' [HG [Hcall [Hcst1 Hcst0]]].
  split.
  intros B W objs free swept ohpSt freePtr stBot stBuff sweepAt numfree A 
    [Hroot [Hphase [Hswsum [Hnumfree [Hst [Hed [HdifW [Hobjs [Hswept [Hat
      [Hset_eq Hp]]]]]]]]]]].
  assert (exists W', exists free', exists swept', exists freePtr',
    exists sweepAt', exists numfree',
      isweepPost s' B W' objs free' swept' ohpSt (rget s rbuff) freePtr'
      stBot stBuff sweepAt' numfree' A /\
      rget s' rbot + 12 * (1 + rget s rsweepsum) =
      12 + rget s rbot + 12 * rget s' rsweepsum).
  apply HG with W free swept freePtr sweepAt numfree; clear HG.
  repeat (split; trivial).
  destruct Hat as [k Hat].
  exists (k + 1).
  omega.
  destruct H as [W0 [free0 [swept0 [freePtr0 [sweepAt0
    [numfree0 [Hpost He]]]]]]].
  exists W0; exists free0; exists swept0; exists freePtr0;
    exists sweepAt0; exists numfree0.
  split; trivial.
  omega.
  split.
  eapply calleeSavedOkTrans.
  2: apply Hcall.
  calleeSavedOkSolver.
  split; trivial.
Qed.

Theorem isweepDoneSomeImplOk :
  iseqOkS isweepP isweepDoneSomePre isweepDoneSomeGuar isweepDoneSomeSweepImpl.
Proof.
  unfold isweepDoneSomeSweepImpl.
  iseqWeakSolver PsimplISweep.
  
  intros s [B [W [objs [free [swept [ohpSt [freePtr [stBot [stBuff [sweepAt
    [numfree [Hroot [Hphase [Hswsum [Hnumfree [Hlt [Hst [Hed [HdifW [Hobjs [Hswept [Hat
      [Hset_eq Hp]]]]]]]]]]]]]]]]]]]]]]].
  assert (Hp' := sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
      sconjComm (sconjAssocR (sconjAssocR Hp))))))))))).
  rewrite (swStep Hp'); trivial.
  assert (Htmp := contUpdateSt Hp' (rget s rfree)).
  clear Hp'; rename Htmp into Hp'.
  hypReplace Hp' (sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
    sconjComm Hp')))))))))))).
  rewrite (swStep Hp'); trivial.
  assert (Htmp := contUpdateSt Hp'
    (rget (uhset s (8 + rget s rgcInfo)(rget s rfree)) rsweep)).
  clear Hp'; rename Htmp into Hp'.
  hypReplace Hp' (sconjAssocL (sconjComm Hp')).
  rewrite (swStep Hp'); trivial.
  split; trivial.
  intros.
  subst s'.

  clear Hp' Hp Hset_eq Hat Hswept Hobjs HdifW Hed Hst Hnumfree Hphase Hlt Hswsum
    Hroot stBuff stBot numfree sweepAt freePtr ohpSt swept free objs W B.

  unfold isweepDoneSomeGuar; unfold isweepDoneSomePreP.
  unfold isweepPost.
  stSimpl.
  split.
  intros B W objs free swept ohpSt freePtr stBot stBuff sweepAt numfree A
    [Hroot [Hphase [Hswsum [Hnumfree [Hlt [Hst [Hed [HdifW [Hobjs [Hswept [Hat
      [Hset_eq Hp]]]]]]]]]]]].
  exists W; exists free; exists swept; exists (rget s rfree).
  exists (rget s rsweep); exists (rget s rnumfree).
  split; trivial.
  repeat (split; trivial).
  omega.
  right.
  split; trivial.
  split; trivial.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm; apply sconjAssocR.
  unfold contL.
  apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR.
  apply uhsetHOS.
  apply contUpdateSt with numfree.
  apply sconjAssocL; apply sconjComm.
  apply uhsetHOS.
  apply contUpdateSt with sweepAt.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply uhsetHOS.
  apply contUpdateSt with freePtr.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR.
  apply Hp.
  split; trivial.
  split; trivial.
  split; trivial.
  calleeSavedOkSolver.
  split; trivial.
Qed.

Theorem isweepFinishedImplOk :
  iseqOkS isweepP isweepFinishedPre isweepFinishedGuar isweepFinishedImpl.
Proof.
  unfold isweepFinishedImpl.
  iseqWeakSolver PsimplISweep.

  intros s [B [objs [free [swept [ohpSt [freePtr [stBot [stBuff [sweepAt
    [numfree [Hroot [Hphase [Hswsum [Hnumfree [Hlt [Hst [Hed [Hobjs [HdisjBF [Hswept
      [Hat [Hset_eq Hp]]]]]]]]]]]]]]]]]]]]]].
  rewrite addiuStep; trivial.
  assert (Hp' := sconjAssocL (sconjAssocL (
      sconjComm (sconjAssocR Hp)))).
  rewrite (lwStep Hp'); trivial.
  assert (HgetSt := contGetEqL Hp').
  hypReplace Hp' (sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
    sconjComm Hp')))))).
  rewrite (swStep Hp'); trivial.
  assert (Htmp := contUpdateSt Hp' 
    (rget (rset (rset s rphase (2 + rget s zero)) rtemp ohpSt) rfree)).
  clear Hp'; rename Htmp into Hp'.
  hypReplace Hp' (sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
    sconjComm (sconjAssocL (sconjAssocL (
    sconjComm Hp')))))))))))).
  rewrite (swStep Hp'); trivial.
  assert (Htmp := contUpdateSt Hp'
    (rget (uhset (rset (rset s rphase (2 + rget s zero)) rtemp ohpSt)
      (4 + (4 + rget s rgcInfo))
      (rget (rset (rset s rphase (2 + rget s zero)) rtemp ohpSt) rfree))
    rtemp)).
  clear Hp'; rename Htmp into Hp'.
  hypReplace Hp' (sconjAssocL (sconjComm Hp')).
  rewrite (swStep Hp'); trivial.
  split; trivial.
  intros.
  subst s'.
  
  clear Hp' Hp Hset_eq Hat Hswept Hobjs HdisjBF Hed Hst Hnumfree Hphase
    Hroot Hlt Hswsum stBuff stBot numfree sweepAt freePtr  swept free objs B.

  unfold isweepFinishedGuar; unfold isweepFinishedPreP.
  unfold isweepPost.
  stSimpl.
  split.
  intros B objs free swept ohpSt0 freePtr stBot stBuff sweepAt numfree A
    [Hroot [Hphase [Hswsum [Hnumfree [Hlt [Hst [Hed [Hobjs [HdisjBF [Hswept [Hat
      [Hset_eq Hp]]]]]]]]]]]].
  exists free; exists swept; exists (rget s rfree).
  assert (Hp' := sconjAssocL (sconjAssocL (
      sconjComm (sconjAssocR Hp)))).
  assert (HgetSt' := contGetEqL Hp').
  rewrite HgetSt in HgetSt'; inversion HgetSt'.
  subst ohpSt0; clear HgetSt' Hp'.

  exists ohpSt; exists (rget s rnumfree).
  split; trivial.
  rewrite <- (set_unionEmpty B).
  repeat (split; trivial).
  left.
  split; trivial.
  split; trivial.
  split; trivial.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm; apply sconjAssocR.
  unfold contL.
  apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR; apply sconjComm.
  apply sconjAssocR.
  apply uhsetHOS.
  apply contUpdateSt with numfree.
  apply sconjAssocL; apply sconjComm.
  apply uhsetHOS.
  apply contUpdateSt with sweepAt.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply uhsetHOS.
  apply contUpdateSt with freePtr.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocL; apply sconjAssocL; apply sconjComm.
  apply sconjAssocR; apply sconjAssocR.
  stSimpl.
  apply sconjAssocL; apply (sconjImpl Hp).
  clear Hp; intros h Hp.
  assert (Hp' : h ||- objHdrs (set_union B free) 0).
  rewrite objHdrsCEq; setoid_rewrite Hset_eq; assumption.
  clear Hp.
  assert (Hp := objHdrsSplit _ _ _ _ Hp' HdisjBF); clear Hp'.
  apply (sconjImpl Hp).
  clear h Hp; intros h Hp.
  apply bobjHdrsIntroLt; trivial.
  intros.
  assert (Htt : set_In x objs).
  setoid_rewrite <- Hset_eq; apply set_union_intro1; trivial.
  subst objs.
  assert (Ht := rangeMSObjsElim x ohpSt (rget s rhpEnd) Htt); clear Htt.
  destruct Ht as [Hgt Hxat].
  omega.
  auto.
  clear Hp; intros h Hp.
  apply (sconjImplR Hp).
  clear h Hp; intros h Hp.
  apply (sconjImplR Hp).
  clear h Hp; intros h Hp.
  eapply sconjIntro with empty_heap h; trivial.
  apply objHpIntroE; apply unitIntro.
  apply heap_joinEmptyL.
  split; trivial.
  split; trivial.
  split; trivial.
  split; trivial.
  calleeSavedOkSolver.
  split; trivial.
Qed.
